/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() { //module container

var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNotEmpty 		= net.jazz.ajax.toolbox.lang.checkNotEmpty;
var findIf					= net.jazz.ajax.toolbox.lang.findIf;
var removeIf				= net.jazz.ajax.toolbox.lang.removeIf;

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
//var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient = {

	TC_SERVICE_URI: "com.ibm.rqm.configuration.common.service.rest.ITestConfigurationRestService",
	TG_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.ITestCaseGroupRestService",
	EWI_REST_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.IExecutionWorkItemRestService",
	TP_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.ITestPlanRestService",
	
	_invokeTestConfigurationService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {

			if(appArgs.interactionLevel) {
				actualArgs.interactionLevel= appArgs.interactionLevel;
			}
			if(appArgs.resourceInfomation){
				actualArgs.resourceInfomation = appArgs.resourceInfomation;
			}
			if(appArgs.weightsJsonString){
				actualArgs.weightsJsonString = appArgs.weightsJsonString;
			}
			if(appArgs.executionEnvTypes){
				actualArgs.executionEnvTypes = appArgs.executionEnvTypes;
			}
			if(appArgs.excludes){
				actualArgs.excludes = appArgs.excludes;
			}
			if(appArgs.includes){
				actualArgs.includes = appArgs.includes;
			}	
		    if(appArgs.groupId) {
				actualArgs.groupId= appArgs.groupId;
			}
			if(appArgs.testCaseId) {
				actualArgs.testCaseId= appArgs.testCaseId;
			}
			if(appArgs.testCaseName) {
				actualArgs.testCaseName= appArgs.testCaseName;
			}
			if(appArgs.groupName) {
				actualArgs.groupName= appArgs.groupName;
			}	
			if(appArgs.ownerId) {
				actualArgs.ownerId= appArgs.ownerId;
			}		
			if(appArgs.itemId) {
				actualArgs.itemId= appArgs.itemId;
			}
			if(appArgs.ewiIds){
				actualArgs.ewiIds= appArgs.ewiIds;
			}
			if(appArgs.isRandomSelectCase){
				actualArgs.isRandomSelectCase = appArgs.isRandomSelectCase;
			}
			if(appArgs.testConfigId) {
				actualArgs.testConfigId = appArgs.testConfigId;
			}	
			if(appArgs.testPhaseId) {
				actualArgs.testPhaseId = appArgs.testPhaseId;
			}
			if(appArgs.testsPlanUUID) {
				actualArgs.testsPlanUUID = appArgs.testsPlanUUID;
			}
			if(appArgs.addedConfigurations) {
				actualArgs.addedConfigurations = appArgs.addedConfigurations;
			}
			if(appArgs.deletedConfigurations) {
				actualArgs.deletedConfigurations = appArgs.deletedConfigurations;
			}
			if(appArgs.testPlanItemId){
				actualArgs.testPlanItemId = appArgs.testPlanItemId;
			}
			if(appArgs.ownerIdArray){
				actualArgs.ownerIdArray = appArgs.ownerIdArray;
			}
			if(appArgs.testPhaseIdArray){
				actualArgs.testPhaseIdArray = appArgs.testPhaseIdArray;
			}
			if(appArgs.executionWorkItemNameArray){
				actualArgs.executionWorkItemNameArray = appArgs.executionWorkItemNameArray;
			}
			if(appArgs.testPlanItemIdArray){
				actualArgs.testPlanItemIdArray = appArgs.testPlanItemIdArray;
			}
			if(appArgs.testConfigIdArray){
				actualArgs.testConfigIdArray = appArgs.testConfigIdArray;
			}
			if(appArgs.testConfigNameArray){
				actualArgs.testConfigNameArray = appArgs.testConfigNameArray;
			}
			if(appArgs.testCaseIdArray){
				actualArgs.testCaseIdArray = appArgs.testCaseIdArray;
			}
			if(appArgs.testCaseNameArray){
				actualArgs.testCaseNameArray = appArgs.testCaseNameArray;
			}
			if(appArgs.defaultScriptIdArray){
				actualArgs.defaultScriptIdArray = appArgs.defaultScriptIdArray;
			}
			if(appArgs.weightArray){
				actualArgs.weightArray = appArgs.weightArray;
			}
			if(appArgs.newConfigurations){
				actualArgs.newConfigurations = appArgs.newConfigurations;
			}
			if(appArgs.newConfigurationNames){
				actualArgs.newConfigurationNames = appArgs.newConfigurationNames;
			}
			actualArgs.processArea = getCurrentProjectArea().itemId;
			
		}
		var serviceRequest= new ServiceRequest(this.TC_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeTGService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.serverId) {
				actualArgs.serverId= appArgs.serverId;
			}
		}
		var serviceRequest= new ServiceRequest(this.TG_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeEWIRestService: function(responseHandler, method, appArgs){
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.id) {
				actualArgs.id= appArgs.id;
			}
			if(appArgs.owner) {
				actualArgs.owner= appArgs.owner;
			}
		}
		var serviceRequest= new ServiceRequest(this.EWI_REST_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeTestPlanRestService: function(responseHandler, method, appArgs){
		var actualArgs= {};
		if (appArgs) {
			if(appArgs.testsPlanUUID) {
				actualArgs.testsPlanUUID= appArgs.testsPlanUUID;
			}
			if(appArgs.addedConfigurations) {
				actualArgs.addedConfigurations= appArgs.addedConfigurations;
			}
			if(appArgs.deletedConfigurations) {
				actualArgs.deletedConfigurations= appArgs.deletedConfigurations;
			}
		}
		var serviceRequest= new ServiceRequest(this.TP_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	postDelete: function(responseHandler, args)
	{
		this._invokeEWIRestService(responseHandler, "postDelete", args);
	},
	
	postUpdateEWI: function(serviceResponseHandler, para) {
	  	this._invokeTestConfigurationService(serviceResponseHandler, "postUpdateEWI", 
			para);
	},
	
	getPreEWIList: function(serviceResponseHandler, para) {
		this._invokeService(serviceResponseHandler, "getPreEWIList", 
			{name: para[0], location: para[1], owner: para[2]});
		},
	
	getTestCaseGroup: function(serviceResponseHandler) {
		this._invokeTGService(serviceResponseHandler, "getTestCaseGroups", {});

	},
	
	postGenerateTestConfigurations: function(serviceResponseHandler, para) {
		this._invokeTestConfigurationService(serviceResponseHandler, "postGenerateTestConfigurations", 
			para);
	},
	
	postGenerateEWIs: function(serviceResponseHandler, para) {
	  	this._invokeTestConfigurationService(serviceResponseHandler, "postGenerateEWIs", 
			para);
	},
	
	postDeleteTestConfiguration: function(serviceResponseHandler, params) {	   
		this._invokeTestConfigurationService(serviceResponseHandler, "postDeleteTestConfiguration", 
			params);
	},
	
	postCheckTestCaseGroupEmpty: function(serviceResponseHandler, params){
		this._invokeTestConfigurationService(serviceResponseHandler, "postCheckTestCaseGroupEmpty", 
			params);
	},
	
	postConfigurationsToTestPlan: function(serviceResponseHandler, params){
		this._invokeTestConfigurationService(serviceResponseHandler, "postConfigurations", 
			params);
	},
	
	getConfigurationsByTestPlan: function(serviceResponseHandler, params){
		this._invokeTestConfigurationService(serviceResponseHandler, "getConfigurations", 
			params);
	},
	
	postCreateConfigurations: function(serviceResponseHandler, params){
		this._invokeTestConfigurationService(serviceResponseHandler, "postCreateConfigurations", 
			params);
	},
	
	postCreateExecutionWorkitems: function(serviceResponseHandler, params){
		this._invokeTestConfigurationService(serviceResponseHandler, "postCreateExecutionWorkitems", 
			params);
	}
};

})();
