/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");

//xojo.require("dojo.string.common");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");

//require all editor types
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
//xojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SizingEditor");
//xojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup");
//xojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup");

(function(){

    //var Utility		= com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    com.ibm.rqm.planning.web.ui.internal.util.EditorFactory = {
      loadEditorWidget: function(widgetClassName, widgetArgs) {
         net.jazz.ajax.core.internal.loader.load_sync(widgetClassName);
         var widgetConstructor = dojo.getObject(widgetClassName);
         var widget = new widgetConstructor();
         widget.initialize(widgetArgs);
         if (widget != null) {
            //alert("Successfully loaded external widget: [" + widgetClassName + "]");
            console.debug("Successfully loaded editor widget: [" + widgetClassName + "]");
         }
         return widget;            
      },
       
        getArtifactEditor: function(artifact, artifactType, parentWidget, listener){
            //args: artifact, artifactType, parentWidget, controller, listener, 
            
            switch (artifactType) {
                case Constants.TYPE_GROUP:
                    var args = {
                        parentController: parentWidget.parentController,
                        testGroup: artifact != null ? artifact : null,
                        showGroups: false,
                        minimal: true,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem}
                        listener: listener
                    }
                    return this.loadEditorWidget("com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor", args);
                    
                case Constants.TYPE_CASE:
                    var args = {
                        parentController: parentWidget.parentController,
                        testCase: artifact != null ? artifact : null,
                        minimal: true,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem}
                        listener: listener
                    }
                    return this.loadEditorWidget("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor", args);
                    
                case Constants.TYPE_SCRIPT:
                    var args = {
                        parentController: parentWidget.parentController,
                        testScript: artifact != null ? artifact : null,
                        minimal: true,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem}
                        listener: listener
                    }
                    return this.loadEditorWidget("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor", args);
                    
                case Constants.TYPE_PLAN_SIZING:
                    var args = {
                        parent: parentWidget.parent,
                        parentController: parentWidget.parentController,
                        parentEditor: parentWidget.parentEditor,
                        minimal: true,
                        sizingArtifact: artifact != null ? artifact : null,
                        showCases: artifact.testCaseDTOs ? true : false,
                        showGroups: artifact.testCaseGroupDTOs ? true : false,
                        showScripts: artifact.testScriptDTOs ? true : false,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem},
                        listener: listener,
                        artifactType: "0"
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.sizing.SizingEditor", args);
                    
                case Constants.TYPE_GROUP_SIZING:
                    var args = {
                        parent: parentWidget.parent,
                        parentController: parentWidget.parentController,
                        parentEditor: parentWidget.parentEditor,
                        minimal: true,
                        sizingArtifact: artifact != null ? artifact : null,
                        showCases: artifact.testCaseDTOs ? true : false,
                        showGroups: artifact.testCaseGroupDTOs ? true : false,
                        showScripts: artifact.testScriptDTOs ? true : false,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem},
                        listener: listener,
                        artifactType: "1"
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.sizing.SizingEditor", args);
                    
                case Constants.TYPE_CASE_SIZING:
                    var args = {
                        parent: parentWidget.parent,
                        parentController: parentWidget.parentController,
                        parentEditor: parentWidget.parentEditor,
                        minimal: true,
                        sizingArtifact: artifact != null ? artifact : null,
                        showCases: artifact.testCaseDTOs ? true : false,
                        showGroups: artifact.testCaseGroupDTOs ? true : false,
                        showScripts: artifact.testScriptDTOs ? true : false,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem},
                        listener: listener,
                        //unitValue: this.unitValue,
                        unitValue: parentWidget.parent && parentWidget.parent["getUnitValue"] ? parentWidget.parent.getUnitValue() : null,
                        artifactType: "2"
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.sizing.SizingEditor", args);
                    
                case Constants.TYPE_SCRIPT_SIZING:
                    var args = {
                        parent: parentWidget.parent,
                        parentController: parentWidget.parentController,
                        parentEditor: parentWidget.parentEditor,
                        minimal: true,
                        sizingArtifact: artifact != null ? artifact : null,
                        showCases: artifact.testCaseDTOs ? true : false,
                        showGroups: artifact.testCaseGroupDTOs ? true : false,
                        showScripts: artifact.testScriptDTOs ? true : false,
                        //listener: {index: listIndex, obj: this, method: this.notifyOfUpdatedItem},
                        listener: listener,
                        artifactType: "3",
                        //unitValue: this.unitValue,
                        unitValue: parentWidget.parent && parentWidget.parent["getUnitValue"] ? parentWidget.parent.getUnitValue() : null
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.sizing.SizingEditor", args);
                    
                case Constants.TYPE_EWILIST:
                    var args = {
                        parentController: parentWidget.parentController,
                        minimal: true,
                        testCase: artifact != null ? artifact : null,
                        listener: listener
                    }
                    return this.loadEditorWidget("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList", args);
                    
                case "Approval":
                    var args = {
                        parentController: parentWidget.parentController,
                        childrenApprovalDTO: artifact != null ? artifact.childrenApprovalDTO : null,
                        itemId: artifact.itemId,
                        contentType: artifact.contentType,
                        artifactType: artifact.relatedArtifactType
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup", args);
                    
                case "ApprovalHistory":
                    var args = {
                        parentController: parentWidget.parentController,
                        history: artifact != null ? artifact : null
                    }
                    return this.loadEditorWidget("com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup", args);
                    
                default:
                    return null;
            }
        }
        
    };
    
})();
