/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");
dojo.require("dijit.form.CheckBox");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
					        '<table>' +
					        	'<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td>'+
								'</tr>' +
						        '<tr><td><div dojoAttachPoint="_content">' +
							        '<table>' +
							        	'<tr><td>' +
							        		'<label><input type="radio" value="labelShowAdapter" dojoAttachPoint="labelShowAdapter" name="adapter" dojoType="dijit.form.CheckBox"/> ${labelShowAdapter}</label>' +
							        	'</td></tr>' +
										'<tr><td>' +
							        		'<label class="note-text">${labelNote}</label><label class="note-text">${labelShowAdapterWarning}</label>' +
							        	'</td></tr>' +
							        '</table>' +
						        '</div></td></tr>' +
					        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_ADAPTERSELECTION_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelNote: Constants.getMessage("labelNote"),
		labelShowAdapter: Constants.getMessage("labelShowAdapter"),
		labelShowAdapterWarning: Constants.getMessage("labelShowAdapterWarning"),
		
		postCreate: function(){
			this.csHelpId = "rqm_auto_adapter.html";
            this.csHelpLabel = Constants.getMessage("labelAdapterSelectHelp");
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.labelShowAdapter, "onChange", this, "onChange");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelAdapterSelection")));
        },

		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
            return [{
                key: this.key,
                value: this.labelShowAdapter.checked
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		displayUserPreference: function(userPreference){
			for(var i = 0; i < userPreference.length; i++){
                this.labelShowAdapter.setChecked(userPreference[i].value);
			}
		},
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		}
    });
    
})();
