/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
		className: "com.ibm.rqm.execution.web.ui.internal.view.administration.ExecutionStatesEditor",
        csHelpId: "rqm_admin_exec_state.html",
		
		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelExecutionStatesHelp"));
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelExecutionStates");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelManageExecutionStates");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			net.jazz.ajax.core.internal.loader.load_async(this.className, dojo.hitch(this, "_showEditor"));
			//this._showEditor();
        },

        _showEditor: function() {
			var editorConstructor = dojo.getObject(this.className);
			if (editorConstructor) {
	            dojox.data.dom.removeChildren(this._content);
	            this._editor = new editorConstructor();
	            this._content.appendChild(this._editor.domNode);            				
			} else {
				console.error(this.declaredClass + ": Unabled to load widget: " + this.className);
			}
		},
        
        getValues: function(){
        	return [];
        }
    });
})();
