/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ReportPropertiesContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

//DEBUG HACK
//xojo.require("com.ibm.rqm.reports.web.ui.internal.view.preferences.ReportsSystemPreferences");

(function(){
    var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
	var ImplWidgetClassName     = "com.ibm.rqm.reports.web.ui.internal.view.preferences.ReportsSystemPreferences";
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ReportPropertiesContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
		
        constructor: function(){
            this.csHelpId = "rqm_admin_report_prop.html";
        },

		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelReportPropertiesHelp"));
        },
		
        setName: function(){
            this.name = Constants.getMessage("labelReportProperties");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelMangeReportHeaderFooter");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function() {
            dojox.data.dom.removeChildren(this._content);		
            net.jazz.ajax.core.internal.loader.load_async(ImplWidgetClassName, dojo.hitch(this, "_showContent"));
        },
		
		_showContent: function() {
            //create the widget
            var constructor = dojo.getObject(ImplWidgetClassName);
            var contentWidget = new constructor({editable: this.isEditable()});
            
            //display the widget
            this.content = contentWidget.domNode;
            this._content.appendChild(this.content);			
		},
        
        getValues: function(){
        	return [];
        }
    });
})();
