/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.dnd.move");
dojo.require("dojox.data.dom");

//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
//    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var RepositoryClient = com.ibm.team.repository.web.client.internal.RepositoryClient;
    var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/approval/HistoryPopup.html"),
        
        constructor: function(args){
//            this._closeImg.src = ImageCache.REMOVE_ENABLED;
			this.parentController = null;
			this._histories = null;
        },
        
        postCreate: function(){
           
        },
        
		initialize: function(args){
			this.parentController = args.parentController;
			 this._history = args.history;
			 this._initialContent();
            this._initialMimi();
        },
		
        _initialContent: function(){
			if (this._history) {
				var appResults = this._history.approvalResults;
				dojox.data.dom.removeChildren(this._mainBody);
				for (var i = 0; i < appResults.length; i++) {
					var child = appResults[i];
					var tr = document.createElement("tr");
					var label = null;
					if(child.approvalType == Constants.TYPE_APPROVER)
					 	label = document.createTextNode("Approver: ");
					else 
						label = document.createTextNode("Reviewer: ");	
					this._addElementToTR(tr, label);
					
					label = document.createTextNode(child.owner.name);
					this._addElementToTR(tr, label);
					
					var str = Constants.APPROVAL_REJECTED_APPROVAL_TABLE;
					if(child.status == Constants.TYPE_APPROVED){
						if(child.approvalType == Constants.TYPE_APPROVER)
							str = Constants.APPROVAL_APPROVED_APPROVAL_TABLE;
						else
							str = Constants.APPROVAL_REVIEWED_APPROVAL_TABLE;
					} 
					label = document.createTextNode(str);
					this._addElementToTR(tr, label);
					
					label = document.createTextNode(child.comments == null ? "" : child.comments[0].content);
					this._addElementToTR(tr, label);
					
					tr.className = "table-row";
					this._mainBody.appendChild(tr);
				}
			}
		},
		
		_addElementToTR: function(row, element, isPoint){
            var td = document.createElement("td");
			td.className = "table-cell";
            td.appendChild(element);
            if (isPoint) {
				td.className += " point";
            }
            row.appendChild(td);
        },
						
		_initialMimi: function() {
			if (this._history != null) {
                var summary = this._history.summary;
                var table = document.createElement("table");
				var body = document.createElement("tbody");
				var tr = document.createElement("tr");
				var td = document.createElement("td");		
				var str = summary.approveNum + " " + Constants.APPROVAL_APPROVED_APPROVAL_TABLE;
                var label = document.createTextNode(str);
				td.appendChild(label);
				tr.appendChild(td);
				body.appendChild(tr);
				var tr = document.createElement("tr");
				var td = document.createElement("td");		
				var str = summary.rejectNum + " " + Constants.APPROVAL_REJECTED_APPROVAL_TABLE;
                var label = document.createTextNode(str);
				td.appendChild(label);
				tr.appendChild(td);
				body.appendChild(tr);
				var tr = document.createElement("tr");
				var td = document.createElement("td");		
				var str = summary.reviewNum + " " + Constants.APPROVAL_REVIEWED_APPROVAL_TABLE;
                var label = document.createTextNode(str);
				td.appendChild(label);
				tr.appendChild(td);
				body.appendChild(tr);
				table.appendChild(body);
                this.minimizedForm.appendChild(table);
            }
        },
        
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
