/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.common.EditableItemSaveParticipant");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.EditableItemSaveParticipant");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");


(function(){ // module container
   var Constants             = com.ibm.rqm.planning.web.client.internal.Constants;
   var EditorUtil            = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;

	var SaveParticipant       = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.EditableItemSaveParticipant", 
      [SaveParticipant], {
			
		constructor: function(args){
         this.parent = null;
         this.artifact = null;
         this.itemType = null;
         this.index = null;
			
			this.name = null;
         this.desc = null;
         this.owner = null;
			
         //expected args
         //this.parent (EditableItemList)
         //this.artifact
         //this.itemType
         //this.index
         
         //the following correspond to the inline entry fields       
         //this.name
         //this.desc
         //this.owner		
			dojo.mixin(this, args);	
		},
		
		getItemId: function() {
			return this.artifact ? this.artifact.itemId : null;
		},
		
      getItemType: function() { 
         return this.itemType; 
      },	
		
		isNew: function() {
			return !(this.artifact && this.artifact.itemId);
		},
		
		// @override for SaveParticipant
      validate: function() {
         if (dojo.trim(this.name.value).length == 0) {
            alert(Constants.getMessage("msgItemNameRequired", this.itemType));
            return false;
         }
         return true;
      },
		
		// @override for SaveParticipant
      getAttributes: function() { 
         var workItemData = {
            state: "1",
            owner: this.owner.value,
            projectAreaName: EditorUtil.getCurrentProjectArea().name
         }
             
         var attributes = {
             newItem: this.isNew(),   
             id: this.isNew() ? null : this.artifact.id,
             name: this.name.value,
             description: this.description.value,  
             ownerId: this.owner.value,
             state: "New", 
             workItemJsonString: dojo.toJson(workItemData)
         };
         if (this.isNew() && this.itemType == Constants.MODEL_TYPE_GROUP) {
            attributes.newTestGroup = true;
         } else if (this.isNew() && this.itemType == Constants.MODEL_TYPE_CASE) {
            attributes.newTestCase = true;
         } else if (this.isNew() && this.itemType == Constants.MODEL_TYPE_SCRIPT) {
            attributes.newScript = true;
         }  
         return attributes;         
      },
		
		// @override for SaveParticipant
      saveFinished: function(savedItem){
			this.artifact = savedItem;
			this.setDirty(false);
         if (!this.parent._containsItemId(this.parent._itemsAdded, savedItem.itemId)) {
            this.parent._itemRetrieved(savedItem, this.index);
         }
      },	
		
      // @override for SaveParticipant
      saveFailed: function(status){
         //TODO how to handle this case?
      } 		
	
	});
	
})();
