/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Menu");
dojo.require("dijit.form.Button");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseEditor");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ServerHealth");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntryDropDownButton");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function() 
{
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
	var AboutDialog = com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog;
	var ServerHealth = com.ibm.rqm.planning.web.ui.internal.view.common.ServerHealth;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
    var ActionBarEntryDropDownButton = com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntryDropDownButton;
    var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;

    var ACTION_ROOT         = "com.ibm.rqm.planning.home.";
    var DISPATCHER          = "actionDispatcher";
    var HOME_ACTION         = "viewUserHome";
	var SEARCH_ACTION       = "doSearch";
	var DEFAULT_SEARCH_MSG  = Constants.getMessage("msgTypeToSearch");

    var JAZZ_ADMIN_PAGE_ID_SERVER = "com.ibm.team.repository.server";
    var JAZZ_ADMIN_PAGE_ID_PROJECTS = "com.ibm.team.process.ProjectAreaManagement";
    var JAZZ_ADMIN_PAGE_ID_USERS = "com.ibm.team.repository.users";
    
    var SERVER_ADMIN_PAGE_ID = "com.ibm.team.process.ProjectAreaManagement";
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar",
		[dijit._Widget, dijit._Templated],
		{
			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/GlobalTaskBar.html"),		
	
            widgetsInTemplate: true,
            
            labelHelp: Constants.getMessage("labelHelp"),
            labelInfoCtr: Constants.getMessage("labelHelpContents"),
            labelAbout: Constants.getMessage("labelAboutDialogTitle"),
			labelServerHealth: Constants.getMessage("labelServerHealth"),
            labelPref: Constants.getMessage("labelPreferences"),
            labelAdmin: Constants.getMessage("labelAdmin"),
            labelSysProperties: Constants.getMessage("labelSystemProperties"),
            labelJazzServerAdmin: Constants.getMessage("labelJazzServerAdmin"),
            labelJazzProjectAdmin: Constants.getMessage("labelJazzProjectAdmin"),
            labelJazzUserAdmin: Constants.getMessage("labelJazzUserAdmin"),
            labelFeedViews: Constants.getMessage("labelFeedViews"),
            
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function()
			{
//                var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
//                if (permissionInitializer && permissionInitializer.canGrantPermission) {
                this.initializeAdmin();
//                } else {
//                    this._adminNodeContainer.style.display = "none";
//                }

                this._infoCtrNode.onClick = dojo.hitch(this, "showInfoCtr");
                this._aboutNode.onClick = dojo.hitch(this, "showAbout");
				this._serverHealthNode.onClick = dojo.hitch(this, "showServerHealth");
                this._prefNode.onClick = dojo.hitch(this, "displayPreferences");
                
				//search button
				var liSearch = this.searchLi;
				var outerDiv = document.createElement("div");
				outerDiv.id = "search-outer-div";
				var innerDiv = document.createElement("div");
				innerDiv.id = "search-inner-div";
				var inputDiv = document.createElement("div");
				inputDiv.id = "search-input-div";
				var input = document.createElement("input");
				input.id = "search-input";
				input.name = "search-input";
				dojo.addClass(input, "search-input-disabled-text");
				input.type = "text";
				input.value = DEFAULT_SEARCH_MSG;
				var inputLabel = document.createElement("label");
				inputLabel.setAttribute("for", "search-input");
				var inputLabelInfo = document.createElement("span");
				inputLabelInfo.style.display = "none";
				inputLabelInfo.appendChild(document.createTextNode(Constants.getMessage("labelGlobalSearchInput")));
				inputLabel.appendChild(inputLabelInfo);
				inputDiv.appendChild(inputLabel);
				inputDiv.appendChild(input);
				
				this._searchText = input;
				input.onfocus = dojo.hitch(this, function() {
					var value = this._searchText.value;
					this._searchText.value = value && value == DEFAULT_SEARCH_MSG ? "" : value;
				});
                input.onblur = dojo.hitch(this, function() {
                    var value = this._searchText.value;
                    this._searchText.value = value && dojo.trim(value) != "" ? value : DEFAULT_SEARCH_MSG;
                });
				input.onkeyup = dojo.hitch(this, function(event) {
                    event = event || window.event;
					if (event.keyCode == dojo.keys.ENTER) this.doSearch();
				});
				
				var button = document.createElement("button");
				button.id = "search-button";
				button.name = Constants.getMessage("labelGlobalSearchButton");
				button.onclick = dojo.hitch(this, "doSearch");
				
				innerDiv.appendChild(inputDiv);
				innerDiv.appendChild(button);
				outerDiv.appendChild(innerDiv);
				liSearch.appendChild(outerDiv);
			},
            
            addHomeLink: function(homeContainer) {
                this.homeContainer = homeContainer;
                PreferenceClient.getCurrentUserPreferences(this, this.addPrefHomeLink, Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key);
            },
            
            addPrefHomeLink: function(userPreference) {
                this.actionBarIsHorizontal = false;
                if (userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key){
                    this.actionBarIsHorizontal = (userPreference.value == "actionBarHorizontal");
                }

                if (this.actionBarIsHorizontal) {
                    this.homeButton = new dijit.form.Button({
                        label: Constants.getMessage("labelHome"),
                        showLabel: true,
                        "class": "com-ibm-rqm-planning-web-menu-bar",
                        onClick: dojo.hitch(this, "showHomePage")
                    });
                    dojo.setObject("com-ibm-rqm-planning-web-home-widget", this.homeButton);
                    this.homeContainer.appendChild(this.homeButton.domNode);
                } else {
                    this.homeLink = document.createElement("a");
                    this.homeLink.innerHTML = Constants.getMessage("labelBackRQMHome");
                    this.homeLink.id = "return-rqm-home-link";
                    this.homeLink.onclick = dojo.hitch(this, "showPrevPage");
                    this.homeLink.style.visibility = "hidden";
					this.homeLink.setAttribute("href", "javascript:{}");
                    dojo.setObject("com-ibm-rqm-planning-web-home-link", this.homeLink);
                    this.homeContainer.appendChild(this.homeLink);
                }
            },
            
			showInfoCtr: function() {
                var infoCtrWindow = window.open("/help/index.jsp", "_help");
                infoCtrWindow.focus();
            },
            
            displayPreferences: function() {
				/*
                var div = document.createElement("div");
                var dialog = new dijit.Dialog({
                    title: Constants.getMessage("labelPreferences"),
                    style: "position: absolute; top: 30%; left: 25%; width: 50%; height:50%"
                }, div);
                dialog.show();
                var preferencesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor();
                dojox.data.dom.removeChildren(dialog.containerNode);
                dialog.containerNode.appendChild(preferencesEditor.domNode);
				dojo.connect(dialog, "hidden", dialog, "uninitialize");
				*/
				var preferencesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor();
	            var dialogArgs = {
					primaryTitle: Constants.getMessage("labelPreferences"),
	                isClosable: true,
	                showActions: false
	            };                
	            this._prefsDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
				dojo.connect(preferencesEditor, "onCloseParentDialog", this._prefsDialog, "close");
	            //this._prefsDialog.setWidth(this.WIDTH);
	            this._prefsDialog.contentContainer.appendChild(preferencesEditor.domNode);
	            this._prefsDialog.open();		
            },

			doSearch: function() {
				var searchText = this._searchText.value;	
				if (searchText && dojo.trim(searchText) != "" && searchText != DEFAULT_SEARCH_MSG) {
					//do the search
					var uri = "#action=" + ACTION_ROOT + DISPATCHER + "&subAction=" + SEARCH_ACTION + "&searchText=" + searchText;
					window.location.href = uri;
				} else {
					alert(Constants.getMessage("promptEnterSearch"));
					this.searchText.focus();
				}
			},			
			
			showAbout: function() {
				var about = new AboutDialog();
            },
			
            showServerHealth: function() {
                var health = new ServerHealth();
            },			

            showHomePage: function() {
                window.location.hash = Utility._getPlanningActionUri("viewUserHome");
                this._updateHomeLinkButton(true);
			},
            
            showPrevPage: function() {
                // previous page URI is set prior to showing the home link
                if (this.homeLink.backURI) {
                    window.location.hash = this.homeLink.backURI;
                } else {
                    window.location.hash = Utility._getPlanningActionUri("viewUserHome");
                }
                this._updateHomeLinkButton(true);
            },
            
            initializeAdmin: function()
            {
                var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
                
				if (permissionInitializer && permissionInitializer.canGrantPermission)
				{
					this._isAdmin = true;
	                var pages = PageRegistry.getPages();
	                this._jazzPageUri = "";
	                for(var i=0; i<pages.length; i++)
	                {
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_SERVER) 
	                    {
	                        this._jazzServerPageUri = pages[i].getUri();
	                    }
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_PROJECTS)
	                    {
	                        this._jazzProjectPageUri = pages[i].getUri();
	                    }
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_USERS)
	                    {
	                        this._jazzUsersPageUri = pages[i].getUri();
	                    }                   
	                }

	                this._serverAdmin.onClick = dojo.hitch(this, "_onClickJazzServerAdmin");
	                this._projectAdmin.onClick = dojo.hitch(this, "_onClickJazzProjectAdmin");
	                this._userAdmin.onClick = dojo.hitch(this, "_onClickJazzUserAdmin");
					
					this._isProjAdmin("true");
                }
				else
				{
					// check if user is a Project Area Admin
					this.isAdmin = false;
			        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_isProjAdmin", "_notProjAdmin");
					PermissionsClient.checkIsProjectAreaAdmin(responseHandler);
                }

			},
			
			_isProjAdmin: function(response)
			{
				if (response == "true")
				{
	                this._sysProp.onClick = dojo.hitch(this, "_onClickSystemProperties");
	                this._feedViews.onClick = dojo.hitch(this, "_onClickFeedViews");
				
					if(!this._isAdmin)
					{
						// turn off admin page stuff and separator
//	            	    this._jazzAdminMenu.style.display = "none";
	                this._separatorAdmin.domNode.style.display = "none";
	                this._serverAdmin.domNode.style.display = "none";
	                this._projectAdmin.domNode.style.display = "none";
	                this._userAdmin.domNode.style.display = "none";
					}
				}
				else
				{
					this._notProjAdmin();
				}
            },
			
			_notProjAdmin: function()
			{
                this._adminNodeContainer.style.display = "none";
			},

            _onClickJazzServerAdmin: function() {
                window.location.hash = this._jazzServerPageUri;
                this._updateHomeLinkButton(false);
            },
            
            _onClickJazzProjectAdmin: function() {
                window.location.hash = this._jazzProjectPageUri;
                this._updateHomeLinkButton(false);
            },

            _onClickJazzUserAdmin: function() {
                window.location.hash = this._jazzUsersPageUri;
                this._updateHomeLinkButton(false);
            },

            _onClickSystemProperties: function() {
                window.location.hash = Utility._getPlanningActionUri("viewSystemProperties");
            },
            
            _onClickFeedViews: function() {
                window.location.hash = Utility._getPlanningActionUri("viewFeedViews");
            },
            
            _updateHomeLinkButton: function(inRQM) {
                if (this.homeLink)
                    this.homeLink.style.visibility = inRQM ? "hidden" : "visible";
                if (this.homeButton) {
                    this.homeButton.setDisabled(inRQM);
                    if (!inRQM)
                        this.homeButton._focused = false;
                }
            }
    
		}
	);
}
)();
