/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.PrimaryActionButton");

dojo.require("dijit.form.Button");

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.PrimaryActionButton",
[dijit.form.Button],
{
    actionLabel: "",  // the action portion of the label string such as "Create" in "Create Test Case"
    itemLabel: "",    // the item portion of the label string such as "Test Case" in "Create Test Case"
    
    templateString:'<div dojoAttachPoint="domNode" dojoAttachEvent="onclick:_onButtonClick,onmouseover:_onMouse,onmouseout:_onMouse,onmousedown:_onMouse">' +
                   '  <table class="primary-action-button" border="0" cellpadd="0" cellspacing="0">' +
                   '    <tr>' +
                   '      <td valign="top"><div class="left-decor"></div></td>' +
                   '      <td valign="middle" align="left" width="100%" class="main-content">' +
                   '        <button class="button-container" dojoAttachPoint="focusNode" tabIndex="${tabIndex}" id="${id}" name="${name}" waiRole="button">' +
                   '          <table class="label-text-container" border="0" cellpadd="0" cellspacing="0">' +
                   '            <tr>' +
                   '              <td valign="middle"><div class="${iconClass}"></div></td>' +
                   '              <td valign="middle" align="left">' +
                   '                <div class="label-text-action" dojoAttachPoint="actionLabelNode"></div>' +
                   '                <div class="label-text-item" dojoAttachPoint="itemLabelNode"></div>' +
                   '              </td>' +
                   '              <td width="100%"></td>' +
                   '            </tr>' +
                   '          </table>' +
                   '        </button>' +
                   '      </td>'+
                   '      <td valign="top"><div class="right-decor"></div></td>' +
                   '    </tr>' +
                   '  </table>' +
                   '</div>',

    postCreate: function() {
        com.ibm.rqm.planning.web.ui.internal.view.common.PrimaryActionButton.superclass.postCreate.apply(this, arguments);
        this.setLabels(this.actionLabel, this.itemLabel);
    },

    setLabels: function(actionLabel, itemLabel) {
        this.actionLabelNode.innerHTML = actionLabel;
        this.itemLabelNode.innerHTML = itemLabel;
    }
    
});
