/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.TestScriptConfigSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

(function() {
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil          = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.TestScriptConfigSelector",
             [dijit._Widget, dijit._Templated], 
{
        
    templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/TestScriptConfigSelector.html"),
				    

    height: "450px", 
    width: "450px", 
    
	labelowner: Constants.getMessage("labelowner"),
	
    postCreate: function(){

		EditorUtil.initContributors(this._owner, null);
    },
    
    initialize: function(args){
		this.selectedItems = args.selectedItems;
        this._showAsDialog();	 
    },
	
	_showAsDialog: function()
    {
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._dialog.setTitle(Constants.getMessage("labelChangeTestScriptProperties"));
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = false;                                
        }
        this._dialog.open(false);
    },  
	
	_okAction: function(){
        var args = {};
        
        args.ids = [];
        for(var i=0; i<this.selectedItems.length; i++){
            args.ids.push(""+this.selectedItems[i].id);
        }
 
        var option = this._owner.options[this._owner.selectedIndex];
        if (option.text != Constants.getMessage("labelUnassigned")) {
            args.ownerId = option.value;
        }
 
        if (this.okCallback) {
            this.okCallback(args);
        }
    },
	
	_cancelAction: function(){
        if (this.cancelCallback) {
            this.cancelCallback();
        }
    }    
});
})();
    
