 /****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIConfigSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var CategoryClient      = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var SelectUtility       = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var FormNumericField    = com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField;
var CategorySelection   = com.ibm.rqm.planning.web.ui.internal.view.construction.CategorySelection;
var EditorUtil          = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;

dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIConfigSelector",
             [dijit._Widget, dijit._Templated], 
{
    templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/EWIConfigSelector.html"),                                  
				    

    height: "450px", 
    width: "400px",
	
	labelWeight: Constants.getMessage("labelWeight"),
	labelPoints: Constants.getMessage("labelPoints"),
	
    postCreate: function(){
	    dojox.data.dom.removeChildren(this._weight);
        this.weightWidget = new FormNumericField({
            fieldLabel: this.labelWeight,
            required: false
        });
		
        this.weightWidget.onValueChanged = dojo.hitch(this, "validate");
        this.weightWidget.setErrorMessage(Constants.getMessage("msgNumericWeightRequired"));
        this.weightWidget.setPromptMessage(Constants.getMessage("msgWeightRequired"));
        this._weight.appendChild(this.weightWidget.domNode);
    },
	
    initialize: function(args){
        this.selectedItems = args.selectedItems;
 		this._showAsDialog();
    },
    
	_showAsDialog: function()
    {
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._dialog.setTitle(Constants.getMessage("labelChangeEWIProperties"));
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
 
            this._dialog.getOkButton().disabled = false;                                
        }
        this._dialog.open(false);
    },  
	
	_okAction: function(){
		var args = {};
 
		if (dojo.trim(this.weightWidget.getValue()).length != 0) {
			args.weight = Number(dojo.trim(this.weightWidget.getValue()));
		}
		
        if (this.okCallback) {
            this.okCallback(args);
        }
    },
	
	_cancelAction: function(){
        if (this.cancelCallback) {
            this.cancelCallback();
        }
    },
 
	validate: function() {
		if (dojo.trim(this.weightWidget.getValue()).length != 0 && this._dialog) {
			var weight = Number(dojo.trim(this.weightWidget.getValue()));
			if (weight != NaN && weight >= 0 ) {
				this._dialog._yesButton.disabled = false;
			}
			else { 
				this._dialog._yesButton.disabled = true;
			}
		}
	}
});
})();
    
