/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ExclusionPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationFilterTableView");

(function() { 

var Constants 					 = com.ibm.rqm.planning.web.client.internal.Constants;
var ConfigurationFilterTableView = com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationFilterTableView;

dojo.declare(
	"com.ibm.rqm.configuration.web.ui.internal.view.configuration.ExclusionPanel",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/ExclusionPanel.html"),
		
		constructor: function(args) {
			 this.env = (args.env != null) ? args.env : null;
			 this.label  = (args.label != null) ? args.label : null;
			 this.panelType = (args.panelType != null) ? args.panelType : null;
		},
		
		postCreate: function() {
			this._appendLabel();
			this._initItemTable();
		},
		
		_initItemTable: function() {
			dojox.data.dom.removeChildren(this._itemListTable);
			this.configurationFilterTableView = new ConfigurationFilterTableView({environments: this.env, tableType: this.panelType});
			this._itemListTable.appendChild(this.configurationFilterTableView.domNode);
		},
		
		_appendLabel: function()	{
			var label = document.createTextNode(this.label);
			this._label.appendChild(label);
		},
		
		getItems: function() {
			var content = this.configurationFilterTableView.getTableViewer().getContent();
			var items = [];
			for(var i = 0; i < content.length; i++){
				items.push(content[i].values);
			}
			return items;
		},

		_error: function(e) {
			if(e && e.message){
				console.error(e.message);
			}else{
				console.error(e);
			}
		}			
	}
);

})();
