/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008-2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

(function(){ // module container
    /* QM objects */
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var TestCaseClient = com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var SaveParticipant = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var SnapshotEnabledEditor = com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor;
    var AbstractArtifactEditor = com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var PlanningClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
    var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var ExecutionPopUp = com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp;
	var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var PrintViewBaseURI = "action=com.ibm.rqm.planning.printview.testCase&id=";
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor", [dijit._Widget, dijit._Templated, SnapshotEnabledEditor, AbstractArtifactEditor, com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/TestCaseEditor.html"),
        //		templateCssPath: xojo.uri.dojoUri("../com.ibm.rqm.planning.web/ui/internal/view/templates/construction/TestCaseEditor.css"),
        
        // object initializer
        constructor: function(args){
            this.initialized = false;			
        },
		 
        // populate the template with data, connect events, and show initial
        // sub-tab
        postCreate: function() {
            this.inherited('postCreate', arguments);
            this.setArtifactType(Constants.TYPE_CASE);
            this.setSnapshotClient(TestCaseClient);         
            
            //internalize params
            if (this.model) {
                this.setArtifactModel(this.model);
                this.model = null;
            }
            if (this.printable) {
                this.setPrintView(true);
				this.setReadOnly(true);
                this.printable = null;
            }			

            //set new/copy/snapshot states      
            this.setCopy(this.copy === true);
            this.setNew(this.kwArgs == null || this.isCopy());                 
            this.setPrintViewURI(PrintViewBaseURI + (this.kwArgs && this.kwArgs.id ? this.kwArgs.id : ""));
            this.setIsSnapshot(!this.isCopy() && this.kwArgs != null && this.kwArgs.revision != null);
			
			            
            //create layout
            this.createLayout();    
            this.setLoading(true);
						                   
            if (this.kwArgs) {                
                var responseHandler = new ServiceResponseHandler(this, "_loadTestCase", "_loadError");
                if (this.kwArgs.uid != null && this.kwArgs.revision != null) {
                    TestCaseClient.getTestCaseRevision(responseHandler, this.kwArgs.uid, this.kwArgs.revision);
                } else {
                    TestCaseClient.getTestCase(responseHandler, this.kwArgs.id);
                }            
            } else {
                this.initialize({
					artifact : this.testCase ? this.testCase : null
				});
            }	
			this._parentTestPlanInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel();
			this._parentTestPlanInfo.getInfoGroup(Constants.getMessage("labelParentTestPlanInfo"), true);		
        },
		
        _loadTestCase: function(cases) {            
            if (!dojo.isArray(cases) || cases.length != 1) {
                this._loadError(new Error(Constants.getMessage("errTestCaseNotFound")));
                return;
            }           
            this.initialize({
				artifact: cases[0]
			});
        },		
        
		//initialize's param should be consistent with others
        initialize: function(args){
			var testCase = (args == null)? null : args.artifact; 
            // clear the section removed list.
            this._sectionsRemoved = [];
           
            if (testCase != null) { 			        
                if (this.isCopy()) {
                    // clear out the snapshot info
                    testCase.snapshotInfo = null;					
					this._setupCopy(testCase);
                }                                                   
                this.setArtifact(testCase);
				this.initialized = true;                
            } 
			
            // if this is a "new" test case, don't set dirty from the start
            this.setDirty(this.isCopy());			

            //update header with title, etc               
            this.updateHeader();          
			
            //load sections      
            this.loadSections(this._sectionsNode, this.isPrintView() ? null : this._tableOfContentsNode);           
     
	        dojox.data.dom.removeChildren(this.getHeader().getInfoAttributesNode());
            this.setOriginator(testCase == null ? null : testCase.originator.name);			
            this.setState(testCase == null ? Constants.STATETRANSITION_STATE_DRAFT : testCase.state); 
			if (this.isNew()) {
                this.showTemplateSelect();			 	
			}			
            if (this.isNew() && !this.isCopy()) {
                this._defaultName = this.getHeader().getTitle();
                this.setLastSaved(Constants.STATUS_NEW);
            }      
            
			this.setCSHelpId("rqm_test_case_overview.html");
			this.setSCHelpButtonLabel(Constants.getMessage("labelTestCaseEditorCSHelp"));			
			this._addRelatedInfo();
			
			//complete loading
			this.setLoadingArtifactComplete();
            
            if (this.isNew() || this.isCopy()) {
                if (this.getHeader().viewEditableTitle) {
                    setTimeout(dojo.hitch(this.getHeader().viewEditableTitle, "focusWithPrompt"), 1);
                }
            }            
        },
        
        createLayout: function() {
            if (this.isPrintView()) {
                this.createPrintViewLayout();
                return;
            }
						
            //content and alternate content nodes for view header layout
            this._snapshotsNode = document.createElement("div");
            this._sectionsNode = document.createElement("div");
            
            //create the common header layout
            this.createHeader("testcase-icon-48", this._sectionsNode, this._snapshotsNode);
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(this.getHeader().domNode);
            
            this.loadTableOfContents(this._tableOfContentsNode);
            
            //create snapshot pane
            this._snapshotsNode.appendChild(this.getSnapshotPane().domNode);
        },
		
        createPrintViewLayout: function() {
            //remove the table of contents node  
            this._layoutRow.deleteCell(0);
            this._sectionsNode = document.createElement("div");
                       
            this.createHeader("testcase-icon-48", this._sectionsNode, null);
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(this.getHeader().domNode);
        },		
		
		//override from AbstractArtifactEditor, add Run button
		createHeader: function(iconClass, contentNode, snapshotsNode) {
            var artifact = this.getArtifact();
			var args = {
                title: this.getHeaderTitle(),
                titleEditable: !(this.isReadOnly()),
                noTitleLabel: Constants.getMessage("labelNewPageNoTitlePrompt", this.getArtifactType()),
                subTitle: this.getHeaderSubTitle(),
                useDualContents: (!this.isPrintView() && contentNode && snapshotsNode),
                mainContentSelectedLabel: Constants.getMessage("labelArtifactOverview", this.getArtifactType()),
                mainContentDeselectedLabel: Constants.getMessage("labelArtifactOverview", this.getArtifactType()),               
                altContentSelectedLabel: Constants.getMessage("labelViewSnapshots"),
                altContentDeselectedLabel: Constants.getMessage("labelViewSnapshots"),
                typeLabel: this.getArtifactType(),
                iconClass: iconClass,
                summary: artifact ? artifact.description : ""
            }
            
			//Check Test Case Execute Permission
			var tc_exec_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE_EXE);
            // default to allow if fail to fetch permission
			this.hasExePermission = !tc_exec_permission ? true : tc_exec_permission 
																	&& tc_exec_permission[PermissionsClient.ACTION_EXECUTE];
            this._header = new ViewHeaderLayout(args);    
			
            //create the save & cancel & run buttons   
			if (!this.isSnapshot()) {
				this._header.onTitleEdited = dojo.hitch(this, "_onTitleChange");
				//dojo.connect(this._header, "onTitleEdited", this, "_onChange");
                if (!this.isPrintView()) {
					if (this.supportsPrintView()) {
                        //this._printButton = this._header.addRightViewAction(Constants.getMessage("labelPrintView"), dojo.hitch(this, "onPrintView"));
						this._printButton = this.addHeaderButton(Constants.getMessage("labelPrintView"), "print-icon-image", dojo.hitch(this, "onPrintView"));						
					}	
                    this._runButton = this.addHeaderButton(Constants.getMessage("labelExeTest"), "execute-icon-image", dojo.hitch(this, "_onExecuteActionClick"));
					if (this.getArtifactModel().isLockSupported()) {
						this._lockButton = this.addHeaderButton(Constants.getMessage("labelLock"), "lock-icon-image", dojo.hitch(this, "_onLock"));
                        this._updateLockAction();
                    }				
	                this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
	                this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
				}
                this.updateSaveable();
				
            } else {
                var onCurrentRev = dojo.hitch(this, "_onCurrentRevisionClick");
                this._currentRevisionButton = this._header.addRightViewAction(Constants.getMessage("labelGotoCurrentRevision"), onCurrentRev);                
            }
			// if the user doesn't have permission to edit,
            // put up a warning in the header to give the user
            // a heads up.
            if(!this.isRolePermitsEdit()) {
                var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", this.getArtifactType());
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
            }
            
            //append buttons if appropriate
            if (contentNode) {
                dojox.data.dom.removeChildren(contentNode);
                this._header.getContentNode().appendChild(contentNode);
                dojo.connect(this._header, "_selectMainContent", this, "_contentSelected");
            }
            if (snapshotsNode) {
                dojox.data.dom.removeChildren(contentNode);
                this._snapshotButton = this._header.addRightViewAction(Constants.getMessage("labelCreateNewSnapshot"), dojo.hitch(this, "onSnapshot"));
                this._header.getAltContentNode().appendChild(snapshotsNode);
                dojo.connect(this._header, "_selectAltContent", this, "_snapshotsSelected");
            }                
            this._contentSelected();
            return this._header;    
		},
		
		//override from AbstractArtifactEditor
        updateSaveable: function() {
            this.inherited('updateSaveable', arguments);
			if (this._runButton && !dojo.hasClass(this._runButton.domNode, "hidden")) {
                var disabled = !this.hasExePermission || !this._saveButton.disabled || this.isSaving() || this.isLoading();
				this._runButton.setDisabled(disabled);
            }
			if(this.isArchived()){
				this._runButton.setDisabled(true);
			}
        },
		
	     _contentSelected: function() {
		 	this.inherited('_contentSelected', arguments);
			if (this._runButton) {
                dojo.removeClass(this._runButton.domNode, "hidden");
            }
		 },
		 
		_snapshotsSelected: function() {
			this.inherited('_snapshotsSelected', arguments);
			if (this._runButton) {
                dojo.addClass(this._runButton.domNode, "hidden");
            }
		},		
		
        getStaticRelatedInfo: function() {
			if(this._parentTestPlanInfo){
				return this._parentTestPlanInfo;
			}else{
				return null;
			}
        },
            
        getStaticRelatedInfoId: function() {
			if(this.getArtifact() && this.getArtifact().id){
				return this.declaredClass + this.getArtifact().id;
			}else{
				var date = new Date();
				return this.declaredClass + date.toString();//"com.ibm.rqm.planning.web.ui.internal.view.planning.TestCaseEditor" + date string. This is the relatedInfomationId of new created Test Case.
			}
        },
		
		_addRelatedInfo: function() {            
            var testcase = this.getArtifact();
            if (testcase) {
                var responseHandler = new ServiceResponseHandler(this, "_addParentPlansInfo", "_error");
				PlanningClient.getRelatedTestPlanByCase(responseHandler, testcase.versionableItemId);
            }            
        },
		
		_addParentPlansInfo: function(plans) {
			if(!plans) {
				return;
			} 
			var group = this._parentTestPlanInfo.getInfoGroup(Constants.getMessage("labelParentTestPlanInfo"));
			dojox.data.dom.removeChildren(group._actionListNode);
			for( var iPlan = 0; iPlan < plans.length; iPlan++ ) {
                var href = Utility.getTestPlanURI({id:plans[iPlan].id});
                var http = href;
                 
                var heading = plans[iPlan].name;                    
                if( heading.length > 32 ) {
                    heading = heading.substring( 0, 28 ) + "...";
                }
                                    
                this._parentTestPlanInfo.addLink(Constants.getMessage("labelParentTestPlanInfo"), heading, http );
            }    
		},     
		
        _setupCopy: function(testCase) {
            // create a save participant for each test script
			var scripts = testCase && testCase.scripts ? testCase.scripts : [];
            if (this.isCopy() && scripts.length > 0) {
                for (var i = 0; i < scripts.length; i++) {
                    var saveParticipant = new SaveParticipant();
                    saveParticipant.setDirty(false);
                    saveParticipant.setItemId(scripts[i].itemId);
                    saveParticipant.setItemType(Constants.MODEL_TYPE_SCRIPT); // com.ibm.rqm.planning.ManualExecutionScript
                    this.getSaveContext().addParticipant(saveParticipant);
                    this.getSaveContext().createReference(this, "testCaseExecutionScriptsAdded", saveParticipant);
                }
            }         
        },		
		
        //@Override this method must be implemented to support locking
        lock: function(serviceResponseHandler) {
            var args = {
                lock: !this.getArtifact().locked,
                versionableItemId: this.getArtifact().versionableItemId
            }
            TestCaseClient.postLockTestCase(serviceResponseHandler, args);
        },
		       
        _saveError: function(status){
            status.caughtAt = "TestCaseEditor#_saveError";
            this.setLastSaved(Constants.STATUS_FAILURE, status);
        },
        
        //@Override for SaveParticipant
        validate: function(){
            //validate fields
            var name = this.getHeader().getTitle();
            if (dojo.trim(name).length == 0) {
                if (this.isNew()) {
                    this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestCase")));
					return false;
                } else {
                    this.getHeader().setTitle(this.getArtifact().name);
                }
            } else if (this._defaultName && name == this._defaultName) {
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
					Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestCase")));
                return false;
            }
            return true;
        },
        
        // @override for SaveParticipant
        getAttributes: function(){
            var testObj = this.inherited('getAttributes', arguments);
            testObj.newTestCase = this.isNew();
            testObj.name = this.getHeader().getTitle();
            testObj.state = this.getStateValue();
            if (this.isNew()) {
                testObj.templateItemId = this.getTemplate().itemId;
				testObj.templateStateId = this.getTemplate().stateId;
            }
						
            // snapshot properties
            if (this._createSnapshot == true) {
                testObj.createSnapshot = true;
                testObj.snapshotName = this._snapshotName;
                testObj.snapshotDescription = this._snapshotDescription;
            }
            
            return testObj;
        },	
        
        // @override for SaveParticipant
        getItemType: function(){
            return Constants.MODEL_TYPE_CASE;
        },
        
        // @override for SaveParticipant
        saveFinished: function(testCase) {
			//State Management 
			//Clear the state changed flag on each save.
			this.setStateChanged(false);            
            this.setPrintViewURI(PrintViewBaseURI + testCase.id);

            this.inherited('saveFinished', arguments);          
            
            if (this._createSnapshot) {
                // refresh the snapshot list
                this.getSnapshotPane().refreshSnapshots();
                
                // unset the snapshot properties on the editor so next save doesn't create a snapshot
                this._createSnapshot = false;
                this._snapshotName = null;
                this._snapshotDescription = null;
            }
			
			this._addRelatedInfo();                                       
        },
        
        getOwnerItemId: function(){
            return this.getArtifact() != null ? this.getArtifact().owner.itemId : null;
        },
        
        _error: function(e){
            console.error("An error occurred: [" + e.message + "] @ TestCaseEditor#_error");
        },

        // handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            // handle test plans deleted
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_CASE)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().id == artifactArray[i].id)) {
                        // it is in the deleted artifacts list, close itself
//                        this._publishSelfClosing();
                        // mark editor with warning of associated test case is changed
						if (!this.isSnapshot()) {
	                        this.getHeader().setStatus(Constants.getMessage("msgEditorTestCaseDeleted"), ViewHeaderLayout.ERROR);
							this.setArchived(true);
							if(this._runButton)
								this._runButton.setDisabled(true);
						}
                        // done updating the editor if it is deleted
                        return;
                    }
                }
            }
			if (artifactType == Constants.TYPE_SCRIPT) {
                // check if changed test script are associated with the test case
                var testScriptSection = this.getSection("com.ibm.rqm.planning.editor.section.testCaseScripts");
                // get the test script section to check
                if (testScriptSection) {
                    for (var i = 0; i < artifactArray.length; i++) {
                        if (testScriptSection._contains(artifactArray[i])) {
                            // changed test script is in the test script section of the test case
                            if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // mark editor with warning of associated test script is deleted
                                this.getHeader().setStatus(Constants.getMessage("msgEditorTestScriptInCaseDeleted"), ViewHeaderLayout.ERROR);
                            } else if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // mark editor with warning of associated test script is changed
                                this.getHeader().setStatus(Constants.getMessage("msgEditorTestScriptInCaseChanged"), ViewHeaderLayout.INFO);
                            }
                            // done updating the editor as long as there is one change
                            return;
                        }
                    }
                }
			}
			if (artifactType == Constants.TYPE_EWI) {
                // check if changed execution workitem are associated with the test case
                var ewiSection = this.getSection("com.ibm.rqm.execution.editor.section.ewis");
                // get the execution workitem section to check
                if (ewiSection) {
                    for (var i = 0; i < artifactArray.length; i++) {
                        if (ewiSection._contains(artifactArray[i])) {
                            // changed execution workitem is in the execution workitem section of the test case
                            if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // mark editor with warning of associated execution workitem is deleted
                                this.getHeader().setStatus(Constants.getMessage("msgEditorEWIInCaseDeleted"), ViewHeaderLayout.INFO);
                            } else if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // mark editor with warning of associated execution workitem is changed
                                this.getHeader().setStatus(Constants.getMessage("msgEditorEWIInCaseChanged"), ViewHeaderLayout.INFO);
                            }
                            // done updating the editor as long as there is one change
                            return;
                        }
                    }
                }
			}
        },
		
		_onExecuteActionClick: function() {
			if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)) {
				var state = this.getArtifact().state;
				if (state != Constants.STATETRANSITION_STATE_APPROVED) {
					var errorStr = Constants.getMessage("msgCannotExecuteTestCaseNotApproved", this.getArtifact().name);
					this.getHeader().setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, errorStr);
					return;
				}
			}
	    	var execPopUp = new ExecutionPopUp();
			var args = {
				testCase: this.getArtifact()
			}
			execPopUp.initialize(args);
		}
    });
    
})();
