/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

(function() { // module container

var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Constants    			= com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil     			= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var AbstractArtifactEditor 	= com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor;
var YesNoDialog				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var ViewHeaderLayout 		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor",
	[dijit._Widget, dijit._Templated, AbstractArtifactEditor],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/TestSuiteEditor.html"),

		// object initializer
		constructor: function(args) {
			this._isInitialized = false;
		},
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {	
            this.inherited('postCreate', arguments);
            this.setArtifactType(Constants.TYPE_SUITE);
		},		
		
		initialize: function(args) {
			 if (this.getArtifact() && this.parentController) {
                args.testSuite = this.getArtifact();
                args.parentController = this.parentController;
            }			
            
            if (args != null) {
                if (args.parentController === null) {
                    throw new Error("TestSuiteEditor#initialize: Missing required parameter 'args.parentController'");
                }
              
                if (args.testSuite != null) {
                    this.setNew(false);
                    this.setArtifact(args.testSuite);
                }
                
                this.parentController = args.parentController;              
                this.setArtifact(args.testSuite);                                                         
                this.initialized = true;
                
            } else if (!this.initialized) {
                throw new Error("TestCaseEditor#initialize: Missing required parameter 'args'");
                return;
            }   
			// if this is a "new" test suite, don't set dirty from the start
			if( args.testSuite == null){
				this.setDirty(false);
			}				

			
			var clientClassName = "com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient";
			if (dojo.getObject(clientClassName)) {
				this._finishInit();
			} else {
	            var cb = dojo.hitch(this, "_finishInit");
	            net.jazz.ajax.core.internal.loader.load_async(clientClassName, cb);				
			}
		},
		
		_finishInit: function(){
            //create the header node
			this.createLayout();
			// context sensitive help moved from section to header
            this.getHeader().setCSHelpId("rqm_test_suite_overview.html");
			this.getHeader().setCSHelpButtonLabel(Constants.getMessage("labelTestSuiteCSHelp"));
            this.getHeader().setSummaryEditable(true);
            this.getHeader().setSummaryLabel(Constants.getMessage("labeldescription"));
			this.getHeader().onSummaryEdited = dojo.hitch(this, this._setEditorDirty);
            this.setLoading(true);
			this._suite = this.getArtifact();
			dojox.data.dom.removeChildren(this.getHeader().getInfoAttributesNode());
			if ( this._suite != null ) {			
				this.setOriginator(this._suite.originator.name);
                this.setOwner(this.isReadOnly() ? this._suite.owner.name : this._suite.owner.itemId);
				if ( this._suite.description != null ) {
                    this.getHeader().setSummary(this._suite.description);
				} else {
                    this.getHeader().setSummary("");
				}
				this.setState(this._suite.state);
			} else {
				this.setNew(true);
				this.setOriginator(EditorUtil.getCurrentContributor().name);
                this.setOwner();
				this.getHeader().setSummary("");
				this.setState(Constants.STATETRANSITION_STATE_DRAFT);
			}
            
            if (this.isNew()) {
                this._defaultName = this.getHeader().getTitle();
                this.setLastSaved(Constants.STATUS_NEW);
            }            
            this.setLoadingArtifactComplete();

            if (this.isNew() || this.isCopy()) {
                if (this.getHeader().viewEditableTitle) {
                    setTimeout(dojo.hitch(this.getHeader().viewEditableTitle, "focusWithPrompt"), 1);
                }
            }
		},
      
      	createLayout: function(){
            this._sectionsNode = document.createElement("div");
            //create the common header layout
            this.createHeader("testsuite-icon-48", this._sectionsNode);
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(this.getHeader().domNode);
            
            //load sections                     
            this.loadSections(this._sectionsNode, this._tableOfContentsNode);    
        },
		
		//override from AbstractArtifactEditor, add Run button
		createHeader: function(iconClass, contentNode, snapshotsNode) {
            this._header = this.inherited('createHeader', arguments);
            //create the save & cancel & run buttons          
            if (!this.isSnapshot()) {
				 dojox.data.dom.removeChildren(this._header.getRightActionsContainer());
				 var self = this;
				var arg = {
            		label: Constants.getMessage("labelExeTestSuite"),
            		showLabel: false,
					iconClass: "execute-icon-image",
            		onClick: function(e) {
						self._onExecuteActionClick();
            		}
        		};
                var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE_EXE;
                var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            
                if (!perm || perm.execute) {
                    this._runButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
                    this._runButton.callback = this._onExecuteActionClick;
                    this._runButton.setDisabled(false);
                    this._header.getRightActionsContainer().appendChild(this._runButton.domNode);
                }
//                this._runButton = this._header.addRightViewAction(Constants.getMessage("labelExeTestSuite"), dojo.hitch(this, "_onExecuteActionClick"));
				this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
                this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
                this.updateSaveable();
            } 
			return this._header;     
		},
		
		//override from AbstractArtifactEditor
		updateSaveable: function() {
            this.inherited('updateSaveable', arguments);
			if (this._runButton) {
            	var disabled = !this._saveButton.disabled || this.isSaving() || this.isLoading() || 
								this.getArtifact() && ( !this.getArtifact().elements || ( this.getArtifact().elements.length == 0 ) );
				this._runButton.setDisabled(disabled);
            }
			if(this.isArchived()){
				this._runButton.setDisabled(true);
			}
        },
		
		 _contentSelected: function() {
		 	this.inherited('_contentSelected', arguments);
			if (this._runButton) {
                dojo.removeClass(this._runButton.domNode, "hidden");
            }
		 },
		 
		_snapshotsSelected: function() {
			this.inherited('_snapshotsSelected', arguments);
			if (this._runButton) {
                dojo.addClass(this._runButton.domNode, "hidden");
            }
		},		
		
		//@Over-riding for AbstractArtifactEditor onSave
		onSave: function(){      
            //clean Header Status: 
			this.getHeader().clearStatus();
			var sections = this.getSections();
			var preProcessorAvailable = false;
			if(!this.validate()){
				return;
			}
			//set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
			this.preProcessor = [];
            for (var i = 0; i < (sections ? sections.length : 0); i++) {
                if (dojo.isFunction(sections[i].preProcess)) {
                    this.preProcessor.push({sectionId: sections[i].config.id,value: false});
					sections[i].preProcess();
					preProcessorAvailable  = true;
                }else{
					this.preProcessor.push({sectionId: sections[i].config.id,value: true});
				}
			}
			if(!preProcessorAvailable)
				this.markSectionComplete();	
        },
			
		_saveTestSuite: function(){
			var sections = this.getSections();
			for (var i = 0; i < (sections ? sections.length : 0); i++) {
                if (sections[i].validate() == false) {
                    return false;
                }
            }  
            //Dont invoke the global save transaction call custom save here                 
            //this.getSaveContext().commit();
			
			var args = {}
			var myAttributes = this.getAttributes();
			for (var element in myAttributes) 
                  args[element] = myAttributes[element];
			args.stateId = this.getStateId();
			var responseHandler = new ServiceResponseHandler(this, "saveFinished", "_saveError");
			com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.postTestExecutionSuiteDTO(responseHandler, args);
		},	
		
		markSectionComplete: function(id, value){
			var wait = false;
			for(var i=0;i<this.preProcessor.length;i++){
				if(id && value){
					if(this.preProcessor[i].sectionId == id){
						this.preProcessor[i].value = value;
					}
				}
				if(this.preProcessor[i].value == false)
					wait = true;
			}
			if(!wait){
				this._saveTestSuite();
			}
		},
		
		_saveError: function(status){
			this.setSaving(false);
			if (status!=null && status.message!=null) {
				var re = /^\[(\d+)\]\s*:\s*/;
				status.message = status.message.replace(re, "");
			}
            this.setLastSaved(Constants.STATUS_FAILURE, status);
		},
		
		// @override for SaveParticipant
		validate: function(){
			//validate fields
            var name = this.getHeader().getTitle();
			if (dojo.trim(name).length == 0) {
				if (this.isNew()) {
					this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestSuite")));
					return false;
				} else {
					this.getHeader().setTitle(this.getArtifact().name);
				}				
			} else if (this._defaultName && name == this._defaultName) {
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestSuite")));
                return false;
            }
			return true;
 		},
		
		// @override for SaveParticipant
 		getAttributes: function(){
			var testObj = this.inherited('getAttributes', arguments);
            testObj.newTestExecutionSuite = this.isNew();
            testObj.id = this.isNew() ? null : this.getArtifact().id;
            testObj.name = this.getHeader().getTitle();
			testObj.owner = this.getOwnerValue() == "null" ? null: this.getOwnerValue();
			testObj.state = this.getStateValue();
			testObj.description = this.getHeader().getSummary();
            return testObj;
 		},
		
		// @override for SaveParticipant
 		getItemType: function()	{
			return Constants.MODEL_TYPE_SUITE;
 		},
		
		// @override for SaveParticipant
 		getItemId: function(){
 			return this.isNew() ? null : this._suite.itemId;
 		},
		
		// @override for SaveParticipant
 		saveFinished: function(testSuite){
			 
			 if(testSuite && testSuite.elements && testSuite.elements.length >0){
			 	for(var i=0;i<testSuite.elements.length;i++){
					testSuite.elements[i].workitem = {};
					testSuite.elements[i].workitem.id = testSuite.elements[i].ewiId;
					testSuite.elements[i].workitem.name = testSuite.elements[i].ewiName;
					testSuite.elements[i].workitem.itemId = testSuite.elements[i].ewiitemId;
					testSuite.elements[i].workitem.archived = testSuite.elements[i].ewiIsArchived;
					testSuite.elements[i].workitem.testCase = testSuite.elements[i].testCase;
					testSuite.elements[i].workitem.weight = testSuite.elements[i].ewiWeight;
					if(testSuite.elements[i].ewiPlanId){
						testSuite.elements[i].workitem.testPlan = {};
						testSuite.elements[i].workitem.testPlan.id = testSuite.elements[i].ewiPlanId;
						testSuite.elements[i].workitem.testPlan.name = testSuite.elements[i].ewiPlanName;
						testSuite.elements[i].workitem.testPlan.versionableItemId = testSuite.elements[i].ewiPlanVersionableItemId;
					}	
					if(testSuite.elements[i].ewiPhaseName){
						testSuite.elements[i].workitem.testPhase = {};
						testSuite.elements[i].workitem.testPhase.name = testSuite.elements[i].ewiPhaseName;
						testSuite.elements[i].workitem.testPhase.itemId = testSuite.elements[i].ewiPhaseItemId;
					}
					if(testSuite.elements[i].scriptId){
						testSuite.elements[i].script = {};
						testSuite.elements[i].script.id = testSuite.elements[i].scriptId;
						testSuite.elements[i].script.name = testSuite.elements[i].scriptName;
						testSuite.elements[i].script.itemId = testSuite.elements[i].scriptItemId;
						testSuite.elements[i].script.stateId = testSuite.elements[i].scriptStateId;
						testSuite.elements[i].script.scriptType = {};
						testSuite.elements[i].script.scriptType.id = testSuite.elements[i].scriptTypeId;
					}
					if(testSuite.elements[i].ewiDefaultScriptId){
						testSuite.elements[i].workitem.defaultScript = {};
						testSuite.elements[i].workitem.defaultScript.id = testSuite.elements[i].ewiDefaultScriptId;
						testSuite.elements[i].workitem.defaultScript.name = testSuite.elements[i].ewiDefaultScriptName;
						testSuite.elements[i].workitem.defaultScript.itemId = testSuite.elements[i].ewiDefaultScriptItemId;
						testSuite.elements[i].workitem.defaultScript.stateId = testSuite.elements[i].ewiDefaultScriptStateId;
						testSuite.elements[i].workitem.defaultScript.scriptType = {};
						testSuite.elements[i].workitem.defaultScript.scriptType.id = testSuite.elements[i].ewiDefaultScriptTypeId;
					}else{
						testSuite.elements[i].workitem.defaultScript = null;
					}	
					testSuite.elements[i].workitem.stateId = testSuite.elements[i].ewiStateId;
					testSuite.elements[i].workitem.configuration = testSuite.elements[i].ewiConfigurationItemId;
					
					delete testSuite.elements[i].ewiId;
					delete testSuite.elements[i].ewiName;
					delete testSuite.elements[i].ewiitemId;
					delete testSuite.elements[i].ewiIsArchived;
					delete testSuite.elements[i].testCase;
					delete testSuite.elements[i].ewiDefaultScriptId;
					delete testSuite.elements[i].ewiDefaultScriptName;
					delete testSuite.elements[i].ewiDefaultScriptItemId;
					delete testSuite.elements[i].ewiDefaultScriptStateId;
					delete testSuite.elements[i].ewiDefaultScriptTypeId;
					delete testSuite.elements[i].ewiConfigurationItemId;
					delete testSuite.elements[i].ewiStateId;
					delete testSuite.elements[i].ewiPlanId;
					delete testSuite.elements[i].ewiPlanName;
					delete testSuite.elements[i].ewiPlanVersionableItemId;
					delete testSuite.elements[i].ewiPhaseItemId;
					delete testSuite.elements[i].ewiPhaseName;
					delete testSuite.elements[i].ewiWeight;
					
					delete testSuite.elements[i].scriptId;
					delete testSuite.elements[i].scriptName;
					delete testSuite.elements[i].scriptItemId;
					delete testSuite.elements[i].scriptStateId;
					delete testSuite.elements[i].scriptTypeId;
				}
			 }
			 
			 this.setStateChanged(false);
			 this.inherited('saveFinished', arguments);              
 		},
		
		// @override for AbstractArtifactEditor for message string
		removeSection: function(sectionId) {
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgRemoveSectionFromTestSuite"),
				yesCallback: function(){
					 //set the section to not visible
            		var section = self.getSection(sectionId);
            		section.setVisible(false);
            
            		//add to the list to be removed
            		self._sectionsRemoved.push(sectionId);
            
            		//update the table of contents
            		self.updateTableOfContents(true); 
					self.setDirty(true);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();   
        },
		
        // handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            // handle test suites deleted
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SUITE)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().id == artifactArray[i].id)) {
                        // it is in the deleted artifacts list, close itself
                        // mark editor with warning of associated test case is changed
                        this.getHeader().setStatus(Constants.getMessage("msgEditorTestSuiteDeleted"), ViewHeaderLayout.ERROR);
                        // done updating the editor if it is deleted
						this.setArchived(true);
						if(this._runButton)
							this._runButton.setDisabled(true);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsUpdated) && (artifactType == Constants.TYPE_CASE)) {
				var found =  false;
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().elements && this.getArtifact().elements.length > 0)) {
                        var suiteElements = this.getArtifact().elements;
						for(var j=0;j<suiteElements.length ; j++){
							var workitem = suiteElements[j].workitem;
							if(workitem && workitem.testCase.id == artifactArray[i].id){
								workitem.testCase = artifactArray[i];
								suiteElements[j].workitem = workitem;
								this.getArtifact().elements.splice(j, 1, suiteElements[j]);
								found = true;
							}
						}
                    }
                }
				if(found){
					this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
					var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
					if(tcSection && tcSection.isInitialized()){
						//if section is open and initialized, reinitialize it on update.
						tcSection.update();
					}
				}
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EWI)) {
                var found = false;
				for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().elements && this.getArtifact().elements.length > 0)) {
                        var suiteElements = this.getArtifact().elements;
						for(var j=0;j<suiteElements.length ; j++){
							var witem = suiteElements[j].workitem;
							if(witem && witem.id == artifactArray[i].id){
								witem.archived = true;//Since deleted safe to say true
								suiteElements[j].workitem = witem;
								this.getArtifact().elements.splice(j, 1, suiteElements[j]);
								found = true;
								//TER information is hidden from the user, user understands only Test case here.
								this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
							}
						}
                    }
                }
				var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
				if(tcSection && tcSection.isInitialized() && found){
					//if section is open and initialized, reinitialize it on update.
					tcSection.update();
				}
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
				var found = false;
				for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().elements && this.getArtifact().elements.length > 0)) {
                        var suiteElements = this.getArtifact().elements;
						for(var j=0;j<suiteElements.length ; j++){
							var witem = suiteElements[j].workitem;
							if(witem){
								if(witem.defaultScript && witem.defaultScript.id == artifactArray[i].id)
									witem.defaultScript = null;
								if(witem && witem.testCase  && witem.testCase.scripts && witem.testCase.scripts.length>0){
									for(var j=0;j<witem.testCase.scripts.length;j++){
										if(witem.testCase.scripts[j].id == artifactArray[i].id){
											witem.testCase.scripts.splice(j,1);
											found = true;
											break;
										}
									}
								}
							}
						}
                    }
                }
				if(found){
					this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
					var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
					if(tcSection && tcSection.isInitialized()){
					//if section is open and initialized, reinitialize it on update.
						tcSection.update();
					}
				}
			}
        },
		
		_setEditorDirty: function(value){
			if(value == "")
				value = true;
			if(value != true && value != false){
				value = true;
			}
			if(!this.isDirty())
				this.setDirty(value);
		},
		
		_onExecuteActionClick: function() {
			net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp", dojo.hitch(this, "_executionSuite"));
		},
		
		_executionSuite: function () {
			if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
				//need to validate that all Test Cases are approved
				var suite = this.getArtifact();
				var testCases = suite.elements;
				var badTestCaseString = "";
				if (testCases && testCases.length > 0){
					for (var i = 0; i < testCases.length; i++){
						var tc = testCases[i];
						var state = tc.workitem.testCase.state;
						if (state != Constants.STATETRANSITION_STATE_APPROVED) 
							badTestCaseString += " " + tc.workitem.testCase.name;
					}
				}
				if (badTestCaseString != ""){  //Found and offending test case so display a message and return
					var errorStr = Constants.getMessage("msgCannotExecuteSuiteTestCaseNotApproved", badTestCaseString);
					this.setHeaderStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
					return;
				}else{
					//check for approved test suite.
					if (!suite.state || suite.state != Constants.STATETRANSITION_STATE_APPROVED){
						var errorStr = Constants.getMessage("msgCannotExecuteTestSuiteNotApproved", suite.name);
						this.setHeaderStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
						return;
					}
				}	
			}
			
			var selPopUp = new com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp();
			selPopUp.initialize(this.getArtifact());
		},
		
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ TestSuiteEditor#_error");
		}
	}
);

}
)();
