/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

AttachmentsPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.AttachmentsPlugin");
AttachmentsPlugin.PLUGIN_ID = 'attachments';

// require the editor plugins to be used...
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._editor._Plugin");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var DOWNLOAD_SERVICE_URI = "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.AttachmentsPlugin", [dijit._editor._Plugin], {
        buttonClass: dijit.form.Button,
        useDefaultCommand: false,
        _initButton: function(){
            var _this = this;
            this.tag = this.command == AttachmentsPlugin.PLUGIN_ID ? 'inserthtml' : 'a';
            this.command = 'inserthtml';
			this.button = new this.buttonClass({
                label: Constants.getMessage("labelAttachments"),
                showLabel: false,
                iconClass: "AttachmentIcon AttachmentIconPos",
                onClick: dojo.hitch(this, "_onOpenDialog"),
                tabIndex: "-1"
            });             
        },
        _onCloseDialog: function(){
			if(this.editor.iframe.contentDocument){
				if (dojo.isIE) {
	                if ("_savedSelection" in this) {
	                    var b = this._savedSelection;
	                    delete this._savedSelection;
	                    this.editor.focus();
	                    var range = this.editor.document.selection.createRange();
	                    range.moveToBookmark(b);
	                    range.select();
	                }
	            } else
	                this.editor.focus();
			}else
				this.editor.toolbar.focus();
			var attachments = this.attachWidget.getData("attachmentView");
			var removedAttachments = this.attachWidget.getRemovedAttachments();			
            this.editor.parentWidget._updateAttachmentProperty(attachments,removedAttachments);			
        },
        _onOpenDialog: function(){
            var a = dojo.withGlobal(this.editor.window, "getAncestorElement", dijit._editor.selection, [this.tag]);
            if (dojo.isIE)
                this._savedSelection = this.editor.document.selection.createRange().getBookmark();
			var allProperties = this.editor.parentWidget._getProperties();
			var properties = allProperties[0];
			var removedAttachments = allProperties[1];
			var attachmentProps = [];
			for(var i=0;i<properties.length;i++){
				if(properties[i].propertyType == "attachmentView")
					attachmentProps.push(properties[i]);
			}
			this.attachWidget = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView();
			this.attachWidget.setData(attachmentProps,removedAttachments);
			var args = {
                primaryTitle: Constants.getMessage("labelAttachments"),
                isClosable: true,
				okCallback:dojo.hitch(this, "_onCloseDialog")
            }
            var dialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
			dialog.setWidth('600px');
			dialog.contentContainer.appendChild(this.attachWidget.domNode);
            dialog.open();				
        },
		updateState: function(){}
    });
})();

dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
    if (o.plugin)
        return;
    switch (o.args.name) {
        case AttachmentsPlugin.PLUGIN_ID:
            o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.AttachmentsPlugin({
                command: o.args.name
            });
    }
});
