//EPB
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

//Clients
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
//Local widget
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper");
(function() { // module container

var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ResultStates					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var MachineDetailSection			= com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails;
var ExecutionResultMapper			= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ExecutionPageBody.html"),
		
		ewiItemId: null,
		runScriptId: null,
		parentController: null,
		widgetsInTemplate: true,
		fetchingScript: false,
		
		constructor: function() {
			this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
		},
		
		postCreate: function() {		
			//TODO will have to change the call to ewi by ewiItemId and runScript by runScriptId
			this.ewiItemId = this.ewi;
			this.runScriptId = this.runScript !="null"?this.runScript:null;
			if(this.runScriptId == null && this.ewi.defaultScript)
				this.runScriptId = this.ewi.defaultScript.id;
			
			if(this._resultId != null){
				var args = {
					resultItemId: this._resultId
				}
				this.fetchingScript = true;
				var responseHandler=new ServiceResponseHandler(this, "_updateScriptId", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
			else{
				if(this.runScriptId != null){
					this.fetchingScript = true;
					var responseHandler = new ServiceResponseHandler(this, "_preInitialize", "_error");			
					TestScriptClient.getTestScript(responseHandler, this.runScriptId);
				}
				else{
					this._preInitialize(null);
				}
			}
		},
		
		_updateScriptId: function(result){
			this._preInitialize(result.script);
		},
		
		
		_preInitialize: function(testScript){
			if(this.fetchingScript && (!testScript || testScript.length > 1)){
				alert(Constants.getMessage("errRetrieveTestScript"));
                return;
			}
			this.fetchingScript = false;
			if(testScript){
				if(testScript.length > 0)
					this.testScript = testScript[0];
				else
					this.testScript = testScript;	
					
				this.runScriptId =  this.testScript.id;
			}
			var responseHandler = new ServiceResponseHandler(this, "_intializeValues", "_error");			
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId, resolveResults: false});
		},

		_intializeValues: function(ewi)	{
			if(!ewi || ewi.length > 1)	{
				alert(Constants.getMessage("errRetrieveEWI"));
                return;
			}
			
			this._ewi = ewi;
			this._ewiStateId = ewi.stateId;
			this.updateStatus(this._ewi.testCase.name + " "+Constants.getMessage("labelExecution"), ImageCache.PROGRESS_START)
			var args={
					parentController: this.parentController,
					/*title: Constants.getMessage("labelEnv"),*/
					tsName: this.testScript? this.testScript.name:"",
					showEnvDetails: false,
					showProgressBar: true,
					ewi: this._ewi
				}
			dojox.data.dom.removeChildren(this._envWidget);
			
			this.envWidget= new com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer(args);
			var params = {
				title: Constants.getMessage("labelTestEnvironment"),
				summary: this.envWidget.domNode
			}
			var envContainer = this._createCollapsibleSection(params)
			this._envWidget.appendChild(envContainer.domNode);
			
			this._initTypeSpecificSection();
		},
		
		onCancel: function(){
			this._typeSpecificSectionWidget.onCancel();
			setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		//This function should be called by child widget to update the status in Title
		updateStatus: function(status, image){
			if(!this._header){
				dojox.data.dom.removeChildren(this.headerNode)
				this.headerNode.appendChild(this._createHeader(status, Constants.getExtensionDisplayMessage(this.testScript.scriptType.name)).domNode)
			}	
			else{
				//Since status will be Executing or paused
				this._header.setTitle(status+" "+this._ewi.testCase.name);
			}
			this._updateBrowserTitle();
		},
		
		//Update ProgressBar on Environment Widget
		updateProgress: function(percent){
			if(this.envWidget)
				this.envWidget.updateProgress(percent)
		},
		
		getProperties: function(){
			return [];
		},
		
		setProperties: function(properties)	{
		},
		
		onShowResult: function(){
			this._typeSpecificSectionWidget.onEndOfExecution();
			setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		setHeaderStatus: function(message, code, error){
			/*
			ViewHeader.ERROR   = 1;
			ViewHeader.SUCCESS = 2;
			ViewHeader.INFO    = 3;
			ViewHeader.WARNING = 4;
			 */
			var details = ""
			if(error && error.message)
				details = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
			if(this._header)
				this._header.setStatus(message, code, details);
		},
		
		clearHeaderStatus: function(){
			this._header.clearStatus();
		},
		
		enableNavigationToResultPage: function(){
			this.cancelButton.disabled = true;
			var self = this;
			var callbackObj = {
				success: function(results){
					if(results && results.length >0){
						var result = results[0];
//						var verdict = null;
//						if(ewi.results){
//							for(var i=0;i<ewi.results.length;i++){
//								if(self._resultId == ewi.results[i].itemId){
//									verdict = ewi.results[i].state.id;
//									break;
//								}
//							}
//						}
						var verdict = result.state ? result.state.id : null; //This has the verdict id
						if(verdict && verdict == ResultStates.ERROR)
							self.setHeaderStatus(Constants.getMessage("msgExeOverWithError"),ViewHeaderLayout.ERROR);
						else if(verdict && verdict == ResultStates.FAILED)
							self.setHeaderStatus(Constants.getMessage("msgExeOverFailed"),ViewHeaderLayout.ERROR);	
						else
							self.setHeaderStatus(Constants.getMessage("msgExeOver"), ViewHeaderLayout.SUCCESS);
						self._ewi.currentResult = result;//Do update here	
						self.showResultButton.disabled = false;
						dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self._ewi]]);
						dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EXE_LOG, [result]]);
					}	
				},
				failure: function(){
					self.showResultButton.disabled = false;
					console.error("failed to fetch result after execution was over, allowing navigation to result");
				}
			}
			var responseHandler = new ExecutionResultMapper(callbackObj, "success", "failure");			
			ResultClient.getExecutionResultSummaryDTOs(responseHandler, {resultItemId: this._resultId});
		},
		
		publishClosure: function(){
			var uri = Utility.startExecution(this.ewi, this.runScript, this._resultId, this.requestId, this.ergId);//This will return the URI of this widget.
			dojo.publish(GlobalEvents.CloseTab, [uri]);
		},
		
	  /////////////////////////////////////////////////////////////////////////////////////////////////////
      //                                   PLUGGABLE SECTION SUPPORT                                   //
      ////////////////////////////////////////////////////////////////////////////////////////////////////      
      _initTypeSpecificSection: function() {
         if (!this._sectionConfig) {
            this._sectionConfig = this._editorRegistry.getEditor(this);  
         }      
         dojox.data.dom.removeChildren(this._executionWidget);
         this._typeSpecificSectionWidget = this._getTypeSpecificSectionWidget();
         this._executionWidget.appendChild(this._typeSpecificSectionWidget.domNode);  
         this._typeSpecificSectionWidget.initialize(); 
      },
      
      _getTypeSpecificSectionWidget: function() {
         var scriptType =  this.testScript ? this.testScript.scriptType : {id:"com.ibm.rqm.planning.common.scripttype.noscript"};
         this._typeSpecificSectionConfig = this._getTypeSectionConfig(scriptType);
         console.info("Dynamic Widget loading...ScriptType: [" + scriptType.id + "]; Widget Id: [" + this._typeSpecificSectionConfig.jsClass + "]");
         net.jazz.ajax.core.internal.loader.load_sync(this._typeSpecificSectionConfig.jsClass);
         var sectionConstructor = dojo.getObject(this._typeSpecificSectionConfig.jsClass);
         var widgetArgs = { parentController: this.parentController, 
							 parentEditor: this,
							 ewiItemId: this.ewiItemId, 
							 script: this.testScript, 
							 _resultId: this._resultId, /*Only useful if paused scripts are supported*/
							requestId: this.requestId,
							ewiConfigId: this._ewi.configuration,
							__ewiObject: this._ewi,
							__scriptObject: this.testScript,
							ergId: this.ergId/*useful in suite updation*/
						};
		 					
         var contributedWidget = new sectionConstructor(widgetArgs);     
         return contributedWidget;
      },
      
      _getTypeSectionConfig: function(scriptType) {
         var found = null;
         var isDefault = false;
         var sections = this._sectionConfig.sections;
         for (var i = 0; i < sections.length; i++) {
            var section = sections[i];
			var properties = section && dojo.isArray(section.properties) ? section.properties : [];
            for (var j = 0; j < properties.length; j++) {
               var attribute = properties[j];
               if (attribute.id == "com.ibm.rqm.planning.common.executionScriptType" && attribute.value == scriptType.id) {
                  return section;
               } else if (attribute.id == "default" && attribute.value == "true") {
                  found = section;
                  isDefault = true;
               }
            }
         }
         if (found != null && isDefault) {
            console.info("No widget found for ScriptType: [" + scriptType.id + "]; Using default Section: [" + found.id + "]");
         }
         return found;          
      },

        _createHeader: function(title, scriptType) {
			var iconClass = "ewi-icon-48";
			var args = {
                title: title,
                typeLabel: Constants.getMessage("labelScriptSuffix", scriptType),
                iconClass: iconClass,
                summary: ""
            }
            this._header = new ViewHeaderLayout(args);            
            //this._header.getRightHeader().innerHTML = "";
			
			this.cancelButton = this._header.addRightViewAction(Constants.getMessage("labelCancel"), dojo.hitch(this, "onCancel"), null, null);
			if(this.ergId)
				this.showResultButton = this._header.addRightViewAction(Constants.getMessage("labelClose"), dojo.hitch(this, "onShowResult"), null, null);
			else
				this.showResultButton = this._header.addRightViewAction(Constants.getMessage("labelCloseAndShowResult"), dojo.hitch(this, "onShowResult"), null, null);
			this.showResultButton.disabled = true;
            return this._header;          
        }, 
		
		_createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},

		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EWI)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this._ewi && (this._ewi.id == artifactArray[i].id)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWIDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.runScriptId && (this.runScriptId == artifactArray[i].id)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWITestScriptDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_CASE)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this._ewi && (this._ewi.testCase.id == artifactArray[i].id)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWITestCaseDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
        },

		_createDetailSection: function(){
			this.machineSection = new MachineDetailSection();
			dojox.data.dom.removeChildren(this._machineDetailSection);
			this._machineDetailSection.appendChild(this.machineSection.domNode);
		},
		
		updateDetailSection: function(adapter){
			if(!this.machineSection){
				this._createDetailSection();
			}
			this.machineSection.initialize({adapter: adapter});
		},
		
		//Override from contentPane and do customCleanup here
		isDirty: function(){
			//Do cleanup call here
			if(dojo.isFunction(this._typeSpecificSectionWidget.cleanUp)){
				this._typeSpecificSectionWidget.cleanUp();
			}
			return false;
		},
		
		_error: function(errorObj) {
			console.error("Error: (message: '" + errorObj.message + "') from Execution Page Body#_error");
		},
		
		_updateBrowserTitle: function(){
			if (this.page) {
				if (this._ewi && this._ewi.testCase && this._ewi.testCase.name){
					this.page.browserTitle =  Constants.getMessage("labelScriptExe") + Constants.getMessage("labelColen") + " " + this._ewi.testCase.name;
				} else{
					this.page.browserTitle =  Constants.getMessage("labelScriptExe");
				}
		
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	
			}
		
		}	     
	});

})();		
