/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.ManualExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer    = com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;

dojo.declare(
   "com.ibm.rqm.execution.web.ui.internal.view.extension.ManualExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_manualExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-ManualExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

   initialize: function(){  
		dojox.data.dom.removeChildren(this._manualExecutionSection);
		var listArgs = {
			parentController: this.parentController,
			ewiItemId: this.ewiItemId, 
			runScriptId: this.script.id, 
			_resultId: this._resultId,
			parentWidget:this.parentEditor,
			parentSection: this,
			requestId: this.requestId,
			ergId: this.ergId,
			__ewiObject: this.__ewiObject,
			__scriptObject: this.__scriptObject
		}    
	    this._manualExecution = new com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution(listArgs); 
		this._manualExecutionSection.appendChild(this._manualExecution.domNode);
   },

   //@Overriden from AbstractArtifactEditorSection
	getHelpContextID: function(){
		return "rqm_manual_test.html";
	}, 
	
	onCancel: function(){
		this._manualExecution.onCancel();
	},
	onEndOfExecution: function(){
		this._manualExecution.onEndOfExecution();
		this.inherited('onEndOfExecution', arguments);
	},
	_error: function(errorObj)   
	{
		alert("Error: (message: '" + errorObj.message + "') from ManualExecutionSection#_error");
	}
});

})();
