/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea");

dojo.declare("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea",
com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea,
{
    _selectedView: null, // currently selected view
    _viewListNode: null,
    _fixedSelection: false,
    
    postCreate: function() {
        com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea.superclass.postCreate.apply(this, arguments);
        this._viewListNode = document.createElement("ul");
        dojo.addClass(this._viewListNode, "com-ibm-asq-common-web-ui-view-nav-button");
        this.containerNode.appendChild(this._viewListNode);
    },
    
    addLink: function(handler, label, callbackData, /* optional */ iconClass) {
        var arg = {
            label: label,
            onClick: function() {
                if (!this.parentNavigator._fixedSelection) {
                    // update the UI to set the new current selected view
                    if (this.parentNavigator._selectedView) {
                        dojo.removeClass(this.parentNavigator._selectedView.focusNode, "view-selected");
                    }
                    this.parentNavigator._selectedView = this;
                    dojo.addClass(this.parentNavigator._selectedView.focusNode, "view-selected");
                }
                this.clientCallback(this.callbackData);
            }
        };
        
        if (iconClass) {
            arg[iconClass] = iconClass;
        }
        var button = new dijit.form.Button(arg);
        dojo.addClass(button.domNode, "com-ibm-asq-common-web-ui-view-nav-button");
        
        // store the client callback and data into the button
        button.clientCallback = handler;
        button.callbackData = callbackData;
        button.parentNavigator = this;
        
        var item = document.createElement("li");
        item.appendChild(button.domNode);

        this._viewListNode.appendChild(button.domNode);
        return button;
    },
    
    addFixedSelectionLink: function(handler, label, callbackData, /* optional */ iconClass) {
        var fixedButton = this.addLink(handler, label, callbackData, iconClass);
        this._fixedSelection = true;
        this._selectedView = fixedButton;
        dojo.addClass(this._selectedView.focusNode, "view-selected");
    }
    
});
