/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() 
{	
	var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

	/**
	 * Widget to display list of link elements in the LeftNavigation.
	 */
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget",
				 [dijit._Widget, dijit._Templated],
		{
			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/planning/SearchNavWidget.html"),
//			templateCssPath: dojo.uri.dojoUri("../com.ibm.rqm.planning.web/ui/internal/view/templates/planning/SearchNavWidget.css"),
			labelNewQuery: Constants.getMessage("labelNewQuery"),
			labelSearch: Constants.getMessage("labelSearch"),
	
			constructor: function() 
			{
				this.controller = null;
			},
	
			postCreate: function() 
			{
//				this.parentController = args.parentController;
				
				dojo.connect(this._searchButton, "onclick", this, this._doSearch);
				dojo.connect(this._newQuery, "onclick", this, this._doNewQuery);
			},
			
			_doSearch: function(e)
			{
				e.preventDefault();
				
				if (this._searchText.textLength > 0)
				{
					window.location.href = Utility.getGenericSearchUri(this._searchText.value);
				}
				else
				{
					alert(Constants.getMessage("labelSearchString"));
				}
			},
			 
			_doNewQuery: function(e)
			{
				e.preventDefault();
				
				window.location.href = Utility.getNewQueryUri();
			} 
		}
	);
}
)();
