/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource");
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

(function(){
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
    var RequirementTableView = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView;
	var RequirementConnectClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	
	// cap max number of import results at 1000
	var MAX						= 50;
	
    /**
     *
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.requirement.web", "ui/internal/view/templates/requirement/RequirementsSource.html"),
        
		labelSource: Constants.getMessage("labelRequirementSource"),
		labelHostName: Constants.getMessage("labelRequirementHostName"),
		labelRequisitePro: Constants.getMessage("labelRequisitePro"),
		labelPort: Constants.getMessage("labelRequirementPort"),
		labelProject: Constants.getMessage("labelRequirementProject"),
		labelLoading: Constants.getMessage("labelLoading"),
		labelUserId: Constants.getMessage("labelRequirementUserId"),
		labelPassword: Constants.getMessage("labelRequirementPassword"),
		labelGettingInfo: Constants.getMessage("labelGettingInfomation"),
		labelType: Constants.getMessage("labelRequirementType"),
		labelImport: Constants.getMessage("labelRequirementImport"),
		labelBack: Constants.getMessage("labelRequirementBack"),
		labelNext: Constants.getMessage("labelRequirementNext"),
		
		invokeTimes: 0,
		
		returnedNum: 0,
		
        constructor: function(args){
            this.onCancel = args.onCancel;
            this.onDone = args.onDone;
			this.requirements = args.requirements;
			this.parent = args.parent;
			this.reqConnection = null;
			this.selectedItemId = null;
			this.project = null;
			this.type = null;
			this.allConnections = new Array();
			this._allImportedReqs = [];
        },
        
        postCreate: function(){
            this._loadConnections();
        },
		
		_loadConnections: function() {
			var responseHandler = new ServiceResponseHandler(this, "_loadReqproProperties", "_error");
            RequirementConnectClient.getRequirementConnectionDTOs(responseHandler, null);
		},
	
        _loadReqproProperties: function(results){
			this._setToNewConnection();
            var select = document.createElement("select");
			SelectUtility.add( select, new Option("", null) );
			this.allConnections = results;
            for (var j = 0; j < (results ? results.length : 0); j++) {
				var option = new Option(results[j].hostname, results[j].id);
				SelectUtility.add( select, option );
            }
            var args = {
                autoComplete: "false",
                onChange: dojo.hitch(this, "_connectionChanged", results)
            }
            this.combo = new dijit.form.ComboBox(args, select);
			this.combo.domNode.style.width = "302pt";
            dojox.data.dom.removeChildren(this._hostName);
            this._hostName.appendChild(this.combo.domNode);
			this.combo._showResultList = function(){
				this.inherited('_showResultList', arguments);
				var parent = this._popupWidget.domNode.parentNode;
				if(parent) {
					parent.style.zIndex = "10009";
				}
			}
        },
        
        _connectionChanged: function(results){
        	var selected = this.combo.getValue();
			if(results && results.length > 0){
				for(var i=0; i<results.length; i++){
					if(results[i].hostname == selected){
						this._port.value = results[i].port;
						this.selectedItemId = results[i].id;
						this.reqConnection = results[i];
						return;
					}
				}
				//new connection is selected again
				this.reqConnection = null;
				this._setToNewConnection();
			}
        },
        
		_onNextToStep2: function(){
			this.combo.domNode.style.display = "none";
			if (this.reqConnection && (this._port.value == this.reqConnection.port)) {
				this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
				this._requirementsource.style.display = "none";
				this._requirementcustomize.className = "show";
				this._requirementcustomize.style.display = "block";
				this._onProjectsLoaded(this.reqConnection);
			}
			else {
				this.hostname = this.combo.getValue();
				this.port = this._port.value;
				if (!this.port) {
					this.port = 80;
				}
				
				var param = {
					hostname: this.combo.getValue(),//this._hostname.value,
					port: (!this._port.value) ? 80 : this._port.value,
					name: this.combo.getValue(),
					connectionType: Constants.getMessage("labelReqProType")
				}
				if (this._isNewConnectDuplicate(param)) {
					if (this.hostname) {
						this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
						this._requirementsource.style.display = "none";
						this._requirementcustomize.className = "show";
						this._requirementcustomize.style.display = "block";
						this.loadProjects(param);
					}
					else {
						this.combo.domNode.style.display = "block";
						this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoHostName"));
					}
				}
			}
        },
		
		_onNextToStep3: function(){
			this.progressInfoIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._imageGettingInfo);
			this._imageGettingInfo.appendChild(img);
			this._toStep3Button.disabled = true;
			
			var param = {
				connectionItemId: this.reqConnection.internalId,
				projectItemId: this._project.value,
				username: this._username.value,
				password: this._password.value
			}
			
			//get project name
			for(var i=0;i<this.projects.length;i++){
				if(this.projects[i].internalId==this._project.value){
					this.importPrjName=this.projects[i].name;
					break;
				}
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_loadStep3", "_errorToStep3");
            RequirementConnectClient.getRequirementProject(responseHandler, param);
		},
		
		_loadStep3: function(project) {
			this.progressInfoIndicator.style.display = "none";
			this._toStep3Button.disabled = false;
            this.setTitle(Constants.getMessage("labelImportRequirementStep3"));
            this._requirementcustomize.style.display = "none";
            this._requirementListDiv.className = "show";
			this._requirementListDiv.style.display = "block";
			this.parent.importFloatingPane.setWidth("76%");
			this.parent.importFloatingPane.updatePosition();
				
            dojox.data.dom.removeChildren(this._requirementList);
            var args = {
                requirements: [],
                editable: true,
                isExternal: true
            };
            this._reqTableViewer = new RequirementTableView(args);
            this._requirementList.appendChild(this._reqTableViewer.domNode);
            
			if (project) {
				this.types = project.types;
				this._createTypeSelection(this.types);
			}
        },
        
		_isNewConnectDuplicate: function(param) {
			if(this.allConnections && this.allConnections.length) {
				for(var i=0; i<this.allConnections.length; i++){
					var connect = this.allConnections[i];
					if( (connect.hostname == param.hostname || "http://"+connect.hostname == param.hostname || connect.hostname == "http://"+param.hostname) && connect.port == param.port){
						var message = Constants.getMessage("msgAddConnection", connect.name, connect.name);
						this._displayAlertDialog(Constants.getMessage("labelAlert"), message);	
						return false;
					}
				}
			}
			return true;
		},
		
        loadProjects: function(param){
            dojox.data.dom.removeChildren(this._project);
            var option = document.createElement("option");
            option.text = option.value = Constants.getMessage("labelLoading");
            this._project.appendChild(option);
            
			var responseHandler = new ServiceResponseHandler(this, "_postNewConnection", "_error");
	        RequirementConnectClient.postRequirementConnection(responseHandler, param);
        },
		
		_postNewConnection: function(conn){
			if(conn && conn.id){
				var responseHandler = new ServiceResponseHandler(this, "_getConnectionById", "_error");
            	RequirementConnectClient.getRequirementConnectionDTOs(responseHandler, {id: conn.id});
			}
			else {
				this._error();
				this._toStep1();
			}
		},
        
		_getConnectionById: function(items){
			if(items && items.length>0){
				this.allConnections = new Array();
				this.allConnections.push(items[0]);
				this._onProjectsLoaded(items[0]);
			}
			else{
				this._error();
				if(items && items.length>0){
					//remove current connection
					var responseHandler = new ServiceResponseHandler(this, "_toStep1", "_error");
            		RequirementConnectClient.getDeleteRequirmentConnection(responseHandler, {id: items[0].id});
				}
			}
		},
		
		_setToNewConnection: function(){
			this._port.value = "";
			this.reqConnection = null;
			this.selectedItemId = null;
		},
		
		 _onProjectsLoaded: function(requirementConnection){
			this.reqConnection = requirementConnection;
			this.projects = requirementConnection.projects;
			dojox.data.dom.removeChildren(this._project);
			if(this.projects && this.projects.length > 0){
				for(var i = 0; i<this.projects.length; i++){
			   		var option = new Option(this.projects[i].name, this.projects[i].internalId);
					SelectUtility.add( this._project, option );
 					if(i == 0)
						option.selected = true;
				}
			}
			else {
				this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoProject"));
			}			
        },
		
		_createTypeSelection: function(types) {
			dojox.data.dom.removeChildren(this._type);
			if (types && types.length > 0) {
				for (var i = 0; i < types.length; i++) {
					var option = new Option(types[i].name, types[i].id);
					SelectUtility.add( this._type, option );
				}
				this._createTables(types[0].items);
			}
		},
		
		_createTables: function(requirements) {
			dojox.data.dom.removeChildren(this._requirementList);
			var args = {
                requirements: [],
                editable: true,
                isExternal: true
            };
			if(requirements && requirements.length > 0 && requirements[0].priority) {
				args = {
                	requirements: [],
                	editable: true,
                	isExternalByPriority: true
            	};
			}
            this._reqTableViewer = new RequirementTableView(args);
            this._requirementList.appendChild(this._reqTableViewer.domNode);
			var newRqe = this._filterExistReq(this.requirements, requirements);
			this._reqTableViewer.refresh(newRqe);
		},
		
		_onTypeChange: function() {
			var requirements = [];
			var typeId = this._type.value;
            if(this.types && this.types.length>0){
				for(var i=0; i<this.types.length; i++){
					if(typeId == this.types[i].id){
						requirements = this.types[i].items;
						break;
					}
				}
			}
			this._createTables(requirements);
		},
        
        _onBackToStep1: function(){
            this.setTitle(Constants.getMessage("labelImportRequirementStep1"));
            this._requirementsource.className = "show";
            this._requirementcustomize.className = "hidden";
			this._requirementsource.style.display = "block";
            this._requirementcustomize.style.display = "none";
			this.combo.domNode.style.display = "block";
        },
        
		 _onBackToStep2: function(){
            this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
            this._requirementcustomize.className = "show";
            this._requirementListDiv.className = "hidden";
			this._requirementcustomize.style.display = "block";
            this._requirementListDiv.style.display = "none";
			this.parent.importFloatingPane.setWidth("60%");
			this.parent.importFloatingPane.updatePosition();
			this._username.value = "";
			this._password.value = "";
			this._finishButton.disabled = false;
        },
		
        _onImport: function(){
            var items = this._reqTableViewer.getSelectedRows();
			if(items==null || items.length==0){
				this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoRequirement"));
				return;
			}
			this._progressIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._image);
			this._image.appendChild(img);
			
            var addedRequirements = [];
			this._finishButton.disabled = true;
            for (var i = 0; i < items.length; i++) {
				if (items[i].status == "removed") {
					this._displayAlertDialog(Constants.getMessage("labelAlert"), items[i].name + " has been removed, it can't be added.");
					this._finishButton.disabled = false;
					return;
				}
				else {	
					var prefix = "reqpro/";
					var protocolAndHost = this.combo.getValue();
					if(protocolAndHost.match(/^https?:\//i)){
						if(protocolAndHost.match(/^https:\//i))
							prefix = "reqprohttps/";
						var idx = protocolAndHost.indexOf("//")+2;
						protocolAndHost = protocolAndHost.substring(idx, protocolAndHost.length);
					}				
					addedRequirements.push({						
						//externalId: "http://" + this.combo.getValue() + ":" + this._port.value + "/ReqWeb/ReqTabbedProp_Page.jsp?ReqKey=" + items[i].reqKey + "&shortCut=true&showMainFrame=true&txtProject="+this.importPrjName+"&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>",						
						//generalize externalid of reqpro requirements like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
						//also support "https" <-> "reqprohttps"			
						externalId: prefix + protocolAndHost + ":" + this._port.value + "/" + this.importPrjName.replace(/ /g,"%20") + "/" + items[i].reqKey,
						internalId: items[i].internalId,
						name: items[i].name ? items[i].name : items[i].tag, // if name is blank, use tag instead
						summary: items[i].description,
						externalTag: items[i].tag,
						priority: items[i].priority,
						reviewStatus: items[i].reviewStatus
					});
				}
            }
			
			//import requirements
			this.invokeTimes = Math.ceil(addedRequirements.length/MAX) ;
			for (var j = 0; j < this.invokeTimes; j++) {
					var startIndex = j * MAX;
					var endIndex = (j==this.invokeTimes-1) ? addedRequirements.length : startIndex + MAX;
					var tmpArray = addedRequirements.slice(startIndex, endIndex);
					
					var responseHandler = new ServiceResponseHandler(this, "_importFinished", "_importFailure");
            		RequirementWorkItemClient.postRequirementWorkItems(responseHandler, {
                		addedRequirements: tmpArray
            		});
			}		
        },
		
		_importFinished: function(requirements) {
			this.returnedNum++;
			for (var j=0; j < (requirements ? requirements.length : 0); j++) {   
			    this._allImportedReqs.push(requirements[j]);                 
            }
			if (this.returnedNum == this.invokeTimes) {
				this.onDone(this._allImportedReqs);
			}
		},
		
		_importFailure: function(error) {
			this.returnedNum++;
			if (this.returnedNum == this.invokeTimes) {
				this.onDone(this._allImportedReqs);
			}
		},
		
		_filterExistReq: function(exists, toBeFilter) {
			if(!toBeFilter || toBeFilter.length == 0 || !exists || exists.length == 0)
				return toBeFilter;
			var newReqs = [];
			var i = 0 , j = 0 , flag;
			var protocolAndHost = this.combo.getValue();
			if(!protocolAndHost.match(/^https?:\//i))
				protocolAndHost = "http://" + protocolAndHost;
			var solidString = protocolAndHost + this.combo.getValue() + ":" + this._port.value + "/ReqWeb/ReqTabbedProp_Page.jsp?ReqKey=";
			while (i < toBeFilter.length) {
				flag = true;
				for (j = 0; j < exists.length; j = j + 1) {
					var externalId = solidString + toBeFilter[i].reqKey + "&Context=1";
					if (exists[j].externalId === externalId) {
						flag = false;
						break;
					}
				}
				if (flag) {
					newReqs.push(toBeFilter[i]);
				}
				i = i + 1;
			}
			return newReqs;
		},
		
		_toStep1: function(result){
			this._onBackToStep1();
			this._loadConnections();
		},
		
		_errorToStep3: function(e) {
			this.progressInfoIndicator.style.display = "none";
			this._toStep3Button.disabled = false;
			this._displayAlertDialog(Constants.getMessage("labelError"), e.message);
		},
		
		_displayAlertDialog: function(title, message) {
	        var alertDialog = new AlertDialog({'message': message});
    	    alertDialog.setSecondaryTitle(title);
        	alertDialog.open();
		},
		
        _error: function(e){
			this._displayAlertDialog(Constants.getMessage("labelError"), e.message);
        }
    });
})();
