//Group Detail View
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
//
// Author: P. Chu
//
// Summary:
//    
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rational.test.lm.web.client.internal.admin");
dojo.require("com.ibm.rational.test.lm.web.client.internal.group");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.GroupUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ProjectArea = com.ibm.team.process.web.client.projectarea;
var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var LOADING = RtlmUiUtil.getMessage("appWorking");
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var machineCol = "machine.id, machine.name, machine.operatingsystem, machine.Manufacturer, machine.assetfamily," +
"VirtualImage.id, VirtualImage.name, VirtualImage.operatingsystem, VirtualImage.ImageType, VirtualImage.assetfamily";
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants; 
var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", 
    [dijit._Widget, dijit._Templated, com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener],
{    
    templateString: '<div class="group-detail-view" dojoAttachPoint="domNode" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode"' +
                    '       titleEditable="true" summaryEditable="true">' +
                    '    <table border="0" dojoAttachPoint="relocateInfoNode">' +
                    '      <tr>' +
                    '        <td valign="middle" nowrap><span dojoAttachPoint="labelStartDate" class="attributes-entry-label"></span></td>' +
                    '        <td valign="middle" nowrap><span dojoAttachPoint="startDateNode"></span></td>' +
                    '        <td valign="middle"></td>' +
                    '        <td valign="middle" nowrap><span dojoAttachPoint="labelTeam" class="attributes-entry-label"></span></td>' +
                    '        <td width="100%" valign="middle">' +
                    '          <label><select dojoAttachPoint="teamAreaSelector" class="attributes-entry-value"></select></label>' +
                    '        </td>' +
                    '      </tr>' +
                    '      <tr>' +
                    '        <td valign="middle" nowrap><span dojoAttachPoint="labelExpirationDate" class="attributes-entry-label"></span></td>' +
                    '        <td valign="middle" nowrap><span dojoAttachPoint="expirationDateNode"></span></td>' +
                    '        <td valign="middle">' +
                    '          <span class="date-container">' +
                    '            <span dojoAttachPoint="labelNeverExpire" class="attributes-entry-label"></span>' +
                    '            <label><input type="checkbox" dojoAttachPoint="expirationDateCheckbox"' +
                    '                   dojoAttachEvent="onclick:_onExpirableChecked">' +
                    '            </input></label>' +
                    '          </span>' +
                    '        </td>' +
                    '      </tr>' +
                    '    </table>' +
                    '    <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer"'+
                    '         dojoAttachPoint="assetsNode" open="true" hideToolbarOnReadOnly="false">' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
	removeAssetActionNode: null,

    // initial status message and state to display when the view is done loading
    statusMessage: null,
    statusState: null,
    
    // the group ID being viewed.
    groupId: null,
    
    // if the group is new (doesn't exist yet)
    isNew: false,
    
    // the actual group object
    group: null,
	originalGroup: null,

    groupService: null,
    
    discardButtonNode: null,
    saveButtonNode: null,

    _startDateField: null,
    _expirationDateField: null,
    
    assetTableViewer: null,
    
    deleted: false, // flag to indicate if this group is deleted

    postCreate: function() {
        this.inherited("postCreate", arguments);

        this.labelTeam.innerHTML = RtlmUiUtil.getMessage("labelRequiredTeamArea");
        this.labelStartDate.innerHTML = RtlmUiUtil.getMessage("labelStartDate");
        this.labelExpirationDate.innerHTML = RtlmUiUtil.getMessage("labelExpirationDate");
        this.labelNeverExpire.innerHTML = RtlmUiUtil.getMessage("labelNeverExpire");
    
        if (this.isNew) {
            this.viewHeaderNode.setCSHelpId("rtlm_create_group.html", com.ibm.rational.test.lm.web.CSHelpID);
			this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil.getMessage("labelHelp", RtlmUiUtil.getMessage("labelNew"), RtlmUiUtil.getMessage("labelGroupType")));
        }
        this.viewHeaderNode.setIconClass("machine-group-icon-48");
        this.viewHeaderNode.setNoValueEditableTitleLabel(RtlmUiUtil.getMessage("labelNewGroupTitlePrompt"));
        this.viewHeaderNode.setTypeLabel(RtlmUiUtil.getMessage("labelGroupType"));
        this.viewHeaderNode.onTitleEdited = dojo.hitch(this, "_onGroupNameChanged");
        this.viewHeaderNode.onSummaryEdited = dojo.hitch(this, "_onDescriptionChanged");

        this.discardButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil.getMessage("discard_button"), dojo.hitch(this, "_onDiscardActionClick"), null, null);
        this.saveButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil.getMessage("save_button"), dojo.hitch(this, "_onSaveActionClick"), null, null);
        
        // create the start date 
        this._startDateField = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            name: "startDate",
            value: "",
            invalidMessage: RtlmUiUtil.getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil.getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_onStartDateChanged"),
            onkeyup: dojo.hitch(this, "_onStartDateChanged"),
            "class": "text-field"
            });
        this.startDateNode.appendChild(this._startDateField.domNode);
        this._startDateField.init();
                            
        // create the expiration date 
        this._expirationDateField = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            name: "expirationDate",
            value: "",
            invalidMessage: RtlmUiUtil.getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil.getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_onExpirationDateChanged"),
            onkeyup: dojo.hitch(this, "_onExpirationDateChanged"),
            "class": "text-field"
            });

        this.expirationDateNode.appendChild(this._expirationDateField.domNode);
        this._expirationDateField.init();

        // set up the TeamArea selector
        this.teamAreaSelector.onchange = dojo.hitch(this, "_onTeamAreaChanged");
        var teamArea = GroupUtil.getAllTeamArea();
       
		SelectUtility.add( this.teamAreaSelector, new Option( "", "" ) );

        for (var i = 0; i < teamArea.length; i++) {
			SelectUtility.add( this.teamAreaSelector, new Option( teamArea[i].name, teamArea[i].uuid ) );
        }

        // relocate the info node in template string to the header
        this.viewHeaderNode.getInfoAttributesNode().appendChild(this.relocateInfoNode);

        // create the assets table
		this.assetTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
        this.assetTableViewer.setContentProvider(new GroupAssetsTable.TableProvider(this));
        this.assetTableViewer.setContentPageSize(15);
        this.assetTableViewer.setTableRowsCheckable(true);
		this.assetTableViewer.setTableListener(new GroupAssetsTable.TableListener(this));
		this.assetTableViewer.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("labelAsset")));

        if (this._hasEditPermission()) {
            this.addResourceButton = this.assetTableViewer.addAction("_addAssets",
                RtlmUiUtil.getMessage("labelAddToGroup"), 
                null, //callback data
                "add-icon-image",
                dojo.hitch(this, "_onAddResourceClick"));
                         
            this.removeAssetActionNode = this.assetTableViewer.addAction("_releaseAssets", // action id
                RtlmUiUtil.getMessage("labelReleaseFromGroup"), // label
                null, //callback data
                "delete-icon-image", //icon class
                dojo.hitch(this, "_onReleaseAssetActionClick")); // callback
            this.removeAssetActionNode.setDisabled(true);        
        }
        this.assetsNode.setTitle(RtlmUiUtil.getMessage("labelGroupAssets"));
        this.assetsNode.setCSHelpId("rtlm_lgroup_sect_labresource.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.assetsNode.setCSHelpButtonLabel(RtlmUiUtil.getMessage("labelHelp", "", RtlmUiUtil.getMessage("labelGroupAssets")));
		this.assetsNode.containerNode.appendChild(this.assetTableViewer.domNode);
		
        this.groupService = new com.ibm.rational.test.lm.web.client.internal.group();

		this._loadForm();
        if (this.isNew) {
            // for new lab resource group set focus to the title
            this.viewHeaderNode.viewEditableTitle.focusWithPrompt();
        }
	},

    _hasEditPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);  
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);           
    },
    
	_loadForm: function() {
        this.viewHeaderNode.clearStatus();
        this.discardButtonNode.disabled = true;
        this.saveButtonNode.disabled = true;
        
        this._clearEdited();
        
        if (this.isNew) {
            this._loadFormAssets();
            this._clearForm();
        } else {
            this._loadGroupById(this.groupId);
        }
	},
	
    _loadGroupById: function(id) {
        this.viewHeaderNode.setProgressStart(LOADING, /*hideContent*/true);
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadGroupSuccess", "_loadGroupFailure");
        this.groupService.getGroupById(responseHandler, id);
    },
    
    _loadGroupSuccess: function(response) {
        // got the group data
        this.group = (response);
		this.stateId = response.stateId;
        
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAssetsSuccess", "_loadAssetsFailure");
        this.groupService.searchForAllAssetsInGroup(responseHandler, this.groupId, machineCol);

        // show the proper asset's name in its parent container.
        dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this.group.name, "machine-group-icon-16", false]);
		
		// update browserTitle
		this._updateBrowserTitle();
    },
    
    _loadGroupFailure: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errLoadGroupInfo"), ViewHeaderLayout.ERROR);    

        var details = (response && response.message) ? response.message : null;
        com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(RtlmUiUtil.getMessage("labelGroupType"), details);
    },
    
    _loadAssetsSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();
        
        this.group.assets = response.Data;
        this._loadFormData();
    },
    
    _loadAssetsFailure: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errLoadAssetInfo"), ViewHeaderLayout.ERROR);    
        this._loadFormData();
    },
    
    _loadFormData: function() {
        // set initial status message when this view is implicitly loaded after saving a new group
        if (this.statusMessage) {
            this.viewHeaderNode.setStatus(this.statusMessage, this.statusState ? this.statusState : ViewHeaderLayout.INFO);
            this.statusMessage = null;
            this.statusState = null;
        }

        // load general group info to header
        this.viewHeaderNode.setTitle(this.group.name);
        this.viewHeaderNode.setSummary(this.group.description ? this.group.description : "");

		this._setTeamAreaValue(this.group.teamArea);
        if(this.group.startDate) {
            this._startDateField.setValue(this.group.startDate);  
        } else {
            this._startDateField.setDisplayedValue("");
        }
        if (this.group.expirable) {
            this._expirationDateField.setValue(this.group.expirationDate);
        } else {
            this._expirationDateField.setDisplayedValue("");
        }
        this.expirationDateCheckbox.checked = !this.group.expirable;
        this._expirationDateField.setDisabled(this.expirationDateCheckbox.checked);
        
        // Refresh (discard changes) will reload the form and there could be invalid date in the form.
        // Validate will clear the invalid icon in the fields.
        this._startDateField.validate();
        this._expirationDateField.validate();
        
        // load assets info
        this._loadFormAssets();
        this._updateActionButtons();        
    },
    
    _loadFormAssets: function() {
        this.assetsNode.setSummary((this.group && this.group.assets.length > 0) ?
            RtlmUiUtil.getMessage("msgAssetsNumberInGroup", this.group.assets.length) :
            RtlmUiUtil.getMessage("msgNoAssetInGroup"));
        
		if (this.group)
			this.assetTableViewer.setContent(this.group.assets);
        else
            this.assetTableViewer.setContent([]);
        
		this.assetTableViewer.show();
    },
    
    _onSaveActionClick: function() {
		GroupUtil.setGroupsListValid(false);
        var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_saveFailure");
        
        if (this.isNew) {
            this.groupService.createGroup(responseHandler,
										  this._getTeamAreaValue(),
                                          !this.expirationDateCheckbox.checked,
                                          this.viewHeaderNode.getTitle(),
                                          this.viewHeaderNode.getSummary(),
                                          this.expirationDateCheckbox.checked ? null : this._getDateValue(this._expirationDateField),
                                          this._getDateValue(this._startDateField),
                                          false);
        } else {
            this.groupService.updateGroup(responseHandler,
										  this._getTeamAreaValue(),
                                          this.groupId,
                                          !this.expirationDateCheckbox.checked,
                                          this.viewHeaderNode.getTitle(),
                                          this.viewHeaderNode.getSummary(),
                                          this.expirationDateCheckbox.checked ? null : this._getDateValue(this._expirationDateField),
                                          this._getDateValue(this._startDateField),
										  this.stateId,
                                          false);
        }
        
        this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("savingGroup"));
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("savingGroup"), ViewHeaderLayout.INFO);        
        this.discardButtonNode.disabled = true; 
        this.saveButtonNode.disabled = true;
    },
    
    _getDateValue: function(dateWidget) {
        if (dateWidget && dateWidget.getDisplayedValue())
            return dateWidget.getValue().getTime();
        else
            return null;
    },
    
    _getDateString: function(date) {
        if (!date)
            return "";

        return dojo.date.locale.format(date, { selector: 'date', formatLength: "short" });
    },
    
    _onStartDateChanged: function() {
		this.validateDifference();
        if (!this._startDateField.isValid()) {
            this._startDateEdited = true;
        } else {
            var newValue = this._startDateField.getValue();
            this._startDateEdited = false;
            if (this.isNew) {
                if (newValue) {
                    this._startDateEdited = true;
                }
            } else if ((this.group.startDate && !newValue) ||
                       (!this.group.startDate && newValue) ||
                       (this.group.startDate && newValue && (this.group.startDate.getTime() != newValue.getTime()))) {
                this._startDateEdited = true;
            }
        }
        this._updateActionButtons();
    },

    _onExpirationDateChanged: function() {
        this.validateDifference();
		if (!this._expirationDateField.isValid()) {
            this._expirationDateEdited = true;
        } else {
            var newValue = this._expirationDateField.getValue();
            this._expirationDateEdited = false;
            if (this.isNew) {
                if (newValue) {
                    this._expirationDateEdited = true;
                }
            } else if ((this.group.expirationDate && !newValue) ||
                       (!this.group.expirationDate && newValue) ||
                       (this.group.expirationDate && newValue && (this.group.expirationDate.getTime() != newValue.getTime()))) {
                this._expirationDateEdited = true;
            }
        }
        this._updateActionButtons();
    },

	/*
	 * Since 1.0.1
	 */
	validateDifference:function(){
		//See defect 10191
		var enteredStartTime = this._startDateField.getValue() != null ?this._startDateField.getValue().getTime() : 0;
		var enteredEndTime = this._expirationDateField.getValue() != null ? this._expirationDateField.getValue().getTime() : 0;
		//Extra check, it seems that it is possible not to enter any or to have enter only start/end date also.
		if(	enteredEndTime == 0 || enteredStartTime == 0 ){
			this.invalidDateCombination = false;
			return;
		}
		//If both entered then validate
		var deltaMinutes = enteredEndTime - enteredStartTime;
		if(deltaMinutes < 0 && !this.expirationDateCheckbox.checked){
			this.invalidDateCombination = true;
		}else{
			this.invalidDateCombination = false;
		}
	},
	
    _onExpirableChecked: function() {
        this._expirableEdited = false;
        this._expirationDateField.setDisabled(this.expirationDateCheckbox.checked);
        
        if (this.expirationDateCheckbox.checked) {
            this._expirationDateEdited = false;
        } else {
            this._onExpirationDateChanged(this._expirationDateField.getValue());
        }
        
        if (this.isNew) {
            this._expirableEdited = this.expirationDateCheckbox.checked;
        } else if (this.group.expirable == this.expirationDateCheckbox.checked) {
            this._expirableEdited = true;
        }
		this.validateDifference();
        this._updateActionButtons();
    },
    
    _onGroupNameChanged: function(name) {
		//With the change that on every keypress the ViewHeaderLayout fireChangeEvent is called but still the onChange event is
		//not called until the editor loses focus.  Thus just set the title here because it is accessed in _updateActionButtons.
		this.viewHeaderNode.setTitle( name );
        this._groupNameEdited = false;
        if (this.isNew) {
            if (name) {
                this._groupNameEdited = true;
            }
        } else if (name != this.group.name) {
            this._groupNameEdited = true;
        }
        this._updateActionButtons();
    },
    
    _onTeamAreaChanged: function() {
        this._teamAreaEdited = false;
        if (this.isNew) {
            if (this._getTeamAreaValue()) {
                this._teamAreaEdited = true;
            }
        } else if (this._getTeamAreaValue() != this.group.teamArea) {
                this._teamAreaEdited = true;
        }
        this._updateActionButtons();
    },
    
    _onDescriptionChanged: function(desc) {
        this._descriptionEdited = false;
        if (this.isNew) {
            if (desc) {
                this._descriptionEdited = true;
            }
        } else if (desc != this.group.description) {
            this._descriptionEdited = true;
        }
        this._updateActionButtons();
    },
    
	_updateActionButtons: function() {
	    if (this.deleted || this._clearingForm)
	       return;

        if (!this._hasEditPermission()) {
            var msg = RtlmUiUtil.getCommonMessage("statusNoEditPerm");
            var details = RtlmUiUtil.getCommonMessage("msgNoEditPermDetails", RtlmUiUtil.getMessage("labelGroupType"));
            
            this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.WARNING, details);
            this.saveButtonNode.disabled = true;
            this.discardButtonNode.disabled = true;
            return;
        }

	       
	    var edited = this._hasEdited();
	    this.discardButtonNode.disabled = !edited;
	    
	    if (this.viewHeaderNode.getTitle() == "") {
			this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgMissingGroupName"), ViewHeaderLayout.ERROR);
			this.saveButtonNode.disabled = true;
		} else if (!this._getTeamAreaValue()) {
			this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgMissingTeamArea"), ViewHeaderLayout.ERROR);
			this.saveButtonNode.disabled = true;
        } else if (!this._startDateField.isValid()) {
            this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgInvalidStartDate"), ViewHeaderLayout.ERROR);
            this.saveButtonNode.disabled = true;
        } else if (!this.expirationDateCheckbox.checked && !this._expirationDateField.isValid()) {
            this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgInvalidEndDate"), ViewHeaderLayout.ERROR);
            this.saveButtonNode.disabled = true;
		}else if (this.invalidDateCombination) {
            this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgInvalidStartEndDates"), ViewHeaderLayout.ERROR);
            this.saveButtonNode.disabled = true;
		} else {
            if(edited) {
                var msgId = (this.isNew) ? "saveNewReminderMsg" : "saveChangeReminderMsg";
                msg = RtlmUiUtil.getMessage(msgId);           
                this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.INFO);        
            }
            else {
                this.viewHeaderNode.clearStatus();                
            }
			this.saveButtonNode.disabled = !edited;
			
			//Update the tab label to show that the group is edited, or not.
        	dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this.group.name, "machine-group-icon-16", edited]);
			
		}
	},
	
    _clearEdited: function() {
        this._groupNameEdited = false;
        this._teamAreaEdited = false;
        this._descriptionEdited = false;
        this._startDateEdited = false;
        this._expirationDateEdited = false;
        this._membersEdited = false;
        this._expirableEdited = false; 
    },
    
	_hasEdited: function() {
        if (this._groupNameEdited ||
            this._teamAreaEdited ||
            this._descriptionEdited ||
            this._startDateEdited ||
            this._expirationDateEdited ||
			this._membersEdited ||
            this._expirableEdited)
            return true;
        return false;
	},
	
	_clearForm: function() {
	    this._clearingForm = true;
        this.viewHeaderNode.setTitle("");
        this.viewHeaderNode.setSummary("");
        this._setTeamAreaValue(null);
        this._startDateField.setDisplayedValue("");
        this._expirationDateField.setDisplayedValue("");
        this.expirationDateCheckbox.checked = false;
        this._onExpirableChecked();
        this._clearingForm = false;
	},
	
    _saveSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();

        var msg = RtlmUiUtil.getMessage("savedSuccessMsg", RtlmUiUtil.getCurrentTimeString());
        this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.SUCCESS);
        this._clearEdited();
        
        if (this.isNew) {
            this.isNew = false;
            this.groupId = response.itemId;
			this.stateId = response.stateId;
            
            // update our URI
            dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, AssetUriUtil.getGroupDetailURI(this.groupId)]);
            dojo.publish(GlobalEvents.ArtifactsAdded, [ RtlmUiUtil.TYPE_GROUP, [ this.group ], AssetUriUtil.getGroupDetailURI(this.groupId) ]);
        } else {
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ RtlmUiUtil.TYPE_GROUP, [ this.group ], AssetUriUtil.getGroupDetailURI(this.groupId) ]);
        }
        this._loadGroupById(this.groupId);
		
		var responseHandler = new ServiceResponseHandler(this, "_refreshSuccess", "_refreshFailure");
        GroupUtil.refresh(responseHandler);
    },
    
    _saveFailure: function(errorType) {
        var details = (errorType && errorType.message) ? errorType.message : null;
        
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errSavingGroup"), ViewHeaderLayout.ERROR, details);

        if(errorType && errorType.message && errorType.message.toLowerCase().indexOf('license') > -1) {
            RtlmUiUtil.showServerErrorMessage(MessageUtil.getMessage(MessageBundle.COMMON, "serverLicenseErrMsg"));                  
        }        
    },
    
    _refreshSuccess: function(response) {
        GroupUtil.setGroupsListValid(true);
    },
    
    _refreshFailure: function(errorType) {
        var details = (errorType && errorType.message) ? errorType.message : null;
        
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errRefreshingGroupList"), ViewHeaderLayout.ERROR, details);

        if(errorType && errorType.message && errorType.message.toLowerCase().indexOf('license') > -1) {
            RtlmUiUtil.showServerErrorMessage(MessageUtil.getMessage(MessageBundle.COMMON, "serverLicenseErrMsg"));                  
        }        
    },
    
    _onDiscardActionClick: function() {
        var args = {
            'message': RtlmUiUtil.getMessage("confirmDiscard"),
            'yesCallback': 
                function(view) {
                    view._loadForm();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil.getMessage("confirmDiscardTitle"));
        confirmDialog.open();
    },

    _onReleaseAssetActionClick: function() {
        var args = {
            'message': RtlmUiUtil.getMessage("confirmReleaseResource"),
            'yesCallback': 
                function(view) {
                    view._releaseAssetAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil.getMessage("confirmReleaseResourceTitle"));
        confirmDialog.open();
    },
    
	_releaseAssetAction: function() {
        if(this.removeAssetActionNode)
		    this.removeAssetActionNode.setDisabled(true);
        var responseHandler = new ServiceResponseHandler(this, "_ReleaseAssetsSuccess", "_ReleaseAssetsFailure");
		var selectedAssets = this.assetTableViewer.getCheckedRows();
		var assets = [];
		if (selectedAssets.length > 0) {
			for (var i = 0; i < selectedAssets.length; i++) {
				if( selectedAssets[i][4] || selectedAssets[i][9] )
					assets.push( ( selectedAssets[i][4] ) ? selectedAssets[i][0] : ( ( selectedAssets[i][9] ) ? selectedAssets[i][5] : selectedAssets[i][0] ) );
			}
			
			this.groupService.deleteAssetsFromGroup(responseHandler, assets);
			this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("labelReleasingAssets"));
		}
    },

    _ReleaseAssetsSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();
		this._membersEdited = true;
		this._loadGroupById(this.groupId);
		this._updateActionButtons();
    },
    
    _ReleaseAssetsFailure: function() {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errReleaseAsssets"), ViewHeaderLayout.ERROR);
    },
    
    _getTeamAreaDisplayValue: function() {
        if (this.teamAreaSelector.value) {
            for (var i = 0; i < this.teamAreaSelector.options.length; i++) {
                if (this.teamAreaSelector.options[i].selected) {
                    return this.teamAreaSelector.options[i].text;
                }
            }
        }
        return "undefined";
    },

    _getTeamAreaValue: function() {
        return this.teamAreaSelector.value;
    },

    _setTeamAreaValue: function(value) {
        this.teamAreaSelector.value = value;
    },
    
    _createLabelInfo: function(label, domNode) {
        var attributeSpan = document.createElement('span');
        var attributeLabel = document.createElement('span');
        var attributeVal = document.createElement('span');
        attributeSpan.className = "attributes-entry";
        attributeLabel.className = "attributes-entry-label";
        attributeLabel.attributeVal = "attributes-entry-value";
        attributeLabel.innerHTML = label;
        attributeVal.appendChild(domNode);
        attributeSpan.appendChild(attributeLabel);
        attributeSpan.appendChild(attributeVal);
        return attributeSpan;
    },

    // update the UI to reflect the group is deleted 
    setGroupDeleted: function() {
        this.deleted = true;
        this.saveButtonNode.disabled = true;
        this.discardButtonNode.disabled = true;
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgGroupDeleted"), ViewHeaderLayout.ERROR);
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about deleted group
        if ((artifactType == RtlmUiUtil.TYPE_GROUP) && (changeType == GlobalEvents.ArtifactsDeleted)) {
            for (var i = 0; i < artifactArray.length; i++) {
                // check if the group of this editor is deleted
                if (artifactArray[i].id == this.groupId) {
                    // update the UI to reflect the config is deleted 
                    this.setGroupDeleted();
                    break;
                }
            }
        }
    },
	
	_onAddResourceClick: function()
	{
		if (this.isNew) 
		{
            new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:RtlmUiUtil.getMessage("msgSaveNewGroupBeforeAddingAssets")}).open();
			return;
		}
		var dialogArgs = {
			title:RtlmUiUtil.getMessage("labelAddToGroup"),
			style: "position: absolute; top: 15%; left: 15%; width: 65%; height: 68%;"
		}
		this.selectDialog = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog(dialogArgs);
		this.selectDialog.setOKAction(dojo.hitch(this,"_onAddOK"));
		this.selectDialog.show();
	},
	
	_onAddOK: function()
	{
		var IDs = this.selectDialog.getSelectedAssetIDs();
		var assetType = this.selectDialog.getAssetType();
        
        if(this.addResourceButton)
		  this.addResourceButton.setDisabled(true);
          
        var responseHandler = new ServiceResponseHandler(this, "_addAssetsSuccess", "_addAssetsFailure");
		var assets = [];
		if (IDs.length > 0) {
			for (var i = 0; i < IDs.length; i++) {
				assets.push(IDs[i]);
			}
			this.groupService.addAssetsToGroup(responseHandler, this.groupId, assets);
			this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("labelReleasingAssets"));
		}
	},
	
	_addAssetsSuccess:function()
	{
        this.viewHeaderNode.setProgressEnd();
		this._membersEdited = true;
		this._loadGroupById(this.groupId);
		this._updateActionButtons();
        
        if(this.addResourceButton)
    		this.addResourceButton.setDisabled(false);
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgAddAssetsSuccess"), ViewHeaderLayout.SUCCESS);
	},
	
    _addAssetsFailure: function() {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errAddAssets"), ViewHeaderLayout.ERROR);
        if(this.addResourceButton)
		    this.addResourceButton.setDisabled(false);
    },
	
	isDirty: function()
	{
		return( this._hasEdited() );
	},
	
	_updateBrowserTitle: function(){
		if (this.page) {
			var	name ;
			if (this.isNew) {
				name = RtlmUiUtil.getMessage("labelCapitalNew");
			}
			else {
				name = this.group.name;
			}
			this.page.browserTitle = RtlmUiUtil.getMessage("pageTitleAssetGroup", name);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle );
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;
		}
	}
	
});

dojo.declare("GroupAssetsTable.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	_assetView: null,
	
	constructor: function(assetView) {
		this._assetView = assetView;
	},
	
    getNumColumns: function(content) {
        return 4;
    },
	
    getColumnHeading: function(content, atColumnIndex) {
        var headings = [
            RtlmUiUtil.getMessage("labelAssetName"),
            RtlmUiUtil.getMessage("labelOS"),
            RtlmUiUtil.getMessage("labelMfrOrType"),
            RtlmUiUtil.getMessage("labelAssetType")
        ];
        return headings[atColumnIndex];
    },

    getColumnHeadingImage: function(content, atColumnIndex) {
        return null;
    },
    
    getIsColumnGroupable: function(content, atColumnIndex) {
		// groupable by column 4, asset type
        return atColumnIndex == 3;     
    },

    getIsColumnSortable: function(content, atColumnIndex) {
		return true;
    },
    
    getColumnWidth: function(content, atColumnIndex) {
        var columnWidth = [
            30, // "Asset Name",
            25, // "Operation System",
            20, // "Manufacturer/Type",
            25 // "Asset Type"
        ];
        return columnWidth[atColumnIndex];
    },
    
    getContentObjects: function(content) {
        // the groups data is already an array
        return content;
    },
    
    getRowDataId: function(rowData) {
        return( ( rowData[ 4 ] ) ? rowData[ 0 ] : ( ( rowData[ 9 ] ) ? rowData[ 5 ] : null ) );
    },

    getCellDisplayType: function(rowData, atColumnIndex) {
        var types = [
            TableConstants.RENDER_TYPE_LINK,   // "Asset Name",
            TableConstants.RENDER_TYPE_TEXT,   // "Operation System",
            TableConstants.RENDER_TYPE_TEXT,   // "Manufacturer",
			TableConstants.RENDER_TYPE_TEXT    // "Asset Type"
        ];
		return types[atColumnIndex];
    },

    _normalizeOSDisplay: function(osName)
    {
        if( osName == null || osName == "OperatingSystem" )
        {
             return "";
        }
        var indx = osName.indexOf("OperatingSystem");
        if( indx > -1) 
        {
            return osName.replace(/OperatingSystem/, RtlmUiUtil.getMessage("unknownOsDisplay"));
        }
        return osName;
    },
        
    getCellDisplayData: function(rowData, atColumnIndex) {
		// line up with the search attribute criteria columns
		if (rowData[4]) {
// "machine.id, machine.name, machine.operatingsystem, machine.owner, machine.assetfamily";
			switch (atColumnIndex) {
				case 0: // Asset Name
					return rowData[1];
				case 1: // "Operation System"
					return this._normalizeOSDisplay(rowData[2]);
				case 2: // "Manufacturer"
					return (rowData[3]) ? rowData[3] : "";
				case 3: // "Asset Type"
					return rowData[4];
			}
		} else if (rowData[9]) {
// "VirtualImage.id, VirtualImage.name, VirtualImage.operatingsystem, VirtualImage.ImageType, VirtualImage.assetfamily";
			switch (atColumnIndex) {
				case 0: // Asset Name
					return rowData[6];
				case 1: // "Operation System"
					return this._normalizeOSDisplay(rowData[7]);
				case 2: // "Manufacturer"
					return (rowData[8]) ? rowData[8] : "";
				case 3: // "Asset Type"
					return rowData[9];
			}
		}

		return "";
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex) {
		if (atColumnIndex == 0) {
			if (rowData[4]) {
            	return { 'href': AssetUriUtil.getViewAssetDetailURI("Machine", rowData[0]) };
			} else if (rowData[9]) {
            	return { 'href': AssetUriUtil.getViewAssetDetailURI("VirtualImage", rowData[5]) };
			}
		}
		
		return( {} );
    }
});

dojo.declare("GroupAssetsTable.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
	_assetView: null,
	
	constructor: function(assetView) {
		this._assetView = assetView;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state) {
		if (this._assetView.removeAssetActionNode)
			this._assetView.removeAssetActionNode.setDisabled(tableViewer.getCheckedRows().length == 0);
    },

    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) {
        callback(callbackData);
    }
});

})();
