/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.HistoryTableProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function() {

	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var column_types = [
						TableConstants.RENDER_TYPE_TEXT,
						TableConstants.RENDER_TYPE_TIMESTAMP,
						TableConstants.RENDER_TYPE_TEXT
					    ];
						
	// Constants used in the eventDescription parsing and translation
	var descriptionSeparator = "&";
    var machineName = "Machine";
    var vmName = "VirtualImage";

						

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.HistoryTableProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider,
{
	constructor: function( column_headings, id_fields )
	{
		this.setParameters( { "column_headings" : this.getColumnHeadings(),
							  "column_types" : column_types } );
	},
	
	getColumnHeadings : function()
	{
		return( [{title: RtlmUiUtil.getMessage("MachLabelEventDescription"), native_column: dojo.hitch( this, this.getEventDescription ), isSortable: true, includeInFilter: true, width: 70},              
        {title: RtlmUiUtil.getMessage("MachLabelTime"), native_column: "time", isSortable: true, includeInFilter: true, width: 15},              
        {title: RtlmUiUtil.getMessage("MachLabelUserid"), native_column: "user", isSortable: true, includeInFilter: true, width: 15}]);
    },

    getEventDescription: function( rowData, atColumnIndex )
    {
        var eventDescription = rowData[ "eventDescription" ];
        var tokens = eventDescription.split(descriptionSeparator);
        if(tokens.length == 1){
            return RtlmUiUtil.getMessage(eventDescription);
        }
        var messageFormat = RtlmUiUtil.getMessage(tokens[0]);
		var qualifier = tokens[1];
		// Special case code to translate asset type
		if(qualifier == machineName || qualifier == vmName){
			qualifier = RtlmUiUtil.getMessage(qualifier);
		}
        var message = dojo.string.substitute(messageFormat, [qualifier]);
        return message;
	}

	
});

})();
