/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");

dojo.require("com.ibm.team.repository.web.foundation.ProgressMonitor");

dojo.require("dojox.data.dom");

dojo.require("net.jazz.ajax.ui.internal.Dialog");

(function(){
	
dojo.declare("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog", 
			 [dijit._Widget, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_deferredContentArea: null,
	_elementList: null,
	_deferredDialog: null,
	_currentSelection: null,
	
	_title: null,
	_message: null,
	_buttons: null,
	_width: "40%",
	_size: 10,
		
	runWithProgress: function(progressMonitoredCode) {
		var monitor= new com.ibm.rqm.defects.web.ui.view.common.DeferredDialog._ProgressMonitor(this);
		this._progressSection.style.visibility= "visible";
		progressMonitoredCode(monitor);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.rqm.defects.web", "ui/view/common/templates/DeferredListDialog.html"),

	postCreate: function() {
		console.dir(this._buttons);
		this._deferredDialog= new com.ibm.rqm.defects.web.ui.view.common.DeferredDialog({
				_contentNode: this._deferredContentArea,
				_buttons: this._buttons,
				_title: this._title,
				_message: this._message,
				_width: this._width
			});
		
		this._elementList.attributes.size= this._size;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	runWithProgress: function(runnable) {
		this._deferredDialog.runWithProgress(runnable);
	},
		
	setElements: function(elements) {
		
		if(elements == null)
			return;
				
		if(!dojo.isArray(elements))
			return;
			
		console.group("_setElement");
		console.dir(elements);
		console.groupEnd();
		
		dojox.data.dom.removeChildren(this._elementList);

		dojo.forEach(elements, dojo.hitch(this, function(element, index, array){
			var option= document.createElement("option");
			option.appendChild(document.createTextNode(element));
			option.setAttribute("value", element);
			
			this._elementList.appendChild(option);
			
			dojo.connect(option, "onchange", function(){
				this._currentSelection= option.attributes.value.value;
			})
		}));
	},
	
	getSelection: function() {
		return this._currentSelection;
	},
	
	close: function() {
		this._dialog.close();
	},

	__sentinel: null // terminates this class definition
});

})();
